dir.create('/pub1/data/mg_projects/users/wangtl/202201/20220811_LIHC.cellAge.scRNA')
setwd('/pub1/data/mg_projects/users/wangtl/202201/20220811_LIHC.cellAge.scRNA')
if (T) {
  dir.create("scripts")
  dir.create("PDFs")
  dir.create("files")
  dir.create("origin_datas/TCGA",recursive = T)
  dir.create("origin_datas/GEO",recursive = T)
  dir.create("results/ana",recursive = T)
  dir.create("results/files",recursive = T)
  dir.create("results/pdf",recursive = T)
  dir.create('origin_datas/scRNA')
}
options(stringsAsFactors = F)
source('/pub1/data/mg_projects/projects/codes/mg_base.R')
#1、单细胞分析####
library(Seurat)
library(dplyr)
library(ggplot2)
library(magrittr)
library(gtools)
library(stringr)
library(Matrix)
library(tidyverse)
library(patchwork)
library(data.table)
library(RColorBrewer)
library(ggpubr)
dir.create('results/ana/01.scRNA')
counts=fread(file = "origin_datas/scRNA/GSE149614_HCC.scRNAseq.S71915.count.txt.gz",data.table = T,sep = '\t',check.names = F)
counts=data.frame(counts)
rownames(counts)=counts[,1]
counts=counts[,-1]
rownames(counts) <- gsub("_","-", rownames(counts))
colnames(counts)
sce<- CreateSeuratObject(counts=counts,project = 'GSE149614',min.cells = 3, min.features = 250) 
Samples1=stringr::str_split_fixed(colnames(sce),'_',2)[,1]
Samples1

sce <- AddMetaData(sce, Samples1,col.name = "Samples")
Sample=unique(Samples1)[grep('T$',unique(Samples1))]

Idents(sce)<-'Samples'
#Sample=as.character(unique(Samples1))
sce_split<-function(sce,Sample,project){
  data.list=list()
  for (i in 1:length(Sample)){
    data.list[[i]]<-subset(sce,idents = Sample[i])
    data.list[[i]]$orig.ident<-project
  }
  names(data.list)=Sample
  return(data.list)
}
datalist=sce_split(sce = sce,Sample=Sample,project='GSE149614')
rm(sce,Sample,counts)
names(datalist)

for (i in 1:length(datalist)){
  sce <- datalist[[i]]
  sce[["percent.mt"]] <- PercentageFeatureSet(sce, pattern = "^MT-")# 计算线粒体占比
  sce[["percent.Ribo"]] <- PercentageFeatureSet(sce, pattern = "^RP[SL]")# 计算rRNA占比
  datalist[[i]] <- sce
  rm(sce)
}

#合并数据
sce <- merge(datalist[[1]],y=datalist[2:length(datalist)])

#细胞数统计
raw_meta=sce@meta.data
raw_count <- table(raw_meta$Samples)
raw_count
sum(raw_count)#34414

sce$nCount_RNA.log=log2(sce$nCount_RNA+1)
sce$nFeature_RNA.log=log2(sce$nFeature_RNA+1)
sce$percent.mt.log=log2(sce$percent.mt+1)
sce$percent.Ribo.log=log2(sce$percent.Ribo+1)

VlnPlot_split<-function(sce,group.by,features,ncols,yname){
  pp=list()
  for (i in 1:length(features)){
    pp[[i]]=VlnPlot(sce,group.by ='Samples', 
                    features = features[i],
                    pt.size = 0)+xlab('')+ylab(yname[i])+
      ggtitle('')+theme(legend.position = 'none')
  }
  pp=ggpubr::ggarrange(plotlist = pp,ncol = ncols)
  return(pp)
}
pearplot_befor<-VlnPlot_split(sce,group.by ='Samples', 
                              features = c("nCount_RNA.log", "nFeature_RNA.log",
                                           "percent.mt.log",'percent.Ribo.log'),
                              ncols = 4,
                              yname=c('log2(nCount_RNA+1)','log2(nFeature_RNA+1)',
                                      'log2(percent.mt+1)','log2(percent.Ribo+1)'))
pearplot_befor



Feature_ber1<-FeatureScatter(sce,feature1 = 'nFeature_RNA',feature2 = 'nCount_RNA',group.by = 'Samples')
Feature_ber2<-FeatureScatter(sce,feature1 = 'percent.mt',feature2 = 'nCount_RNA',group.by = 'Samples')
Feature_ber3<-FeatureScatter(sce,feature1 = 'percent.mt',feature2 = 'nFeature_RNA',group.by = 'Samples')
Feature_ber1=Feature_ber1+theme(legend.position = 'none')
Feature_ber2=Feature_ber2+theme(legend.position = 'none')

Feature_ber<-mg_merge_plot(Feature_ber1,Feature_ber2,Feature_ber3,ncol = 3,nrow = 1,widths = c(1,1,1.2))

VlnPlot(sce,group.by ='Samples', 
              features = c("nCount_RNA", "nFeature_RNA",
                           "percent.mt",'percent.Ribo'),
              ncol = 4,pt.size = 0)

#过滤
datalist <- lapply(X = datalist, FUN = function(x) {
  x<-subset(x,subset =  nFeature_RNA < 5000 & 
              nCount_RNA > 100 &
              percent.mt <15 )
})

#合并数据
sce <- merge(datalist[[1]],y=datalist[2:length(datalist)])
clean_meta=sce@meta.data

clean_count <- table(clean_meta$Samples)
clean_count
sum(clean_count)#33117


sce$nCount_RNA.log=log2(sce$nCount_RNA+1)
sce$nFeature_RNA.log=log2(sce$nFeature_RNA+1)
sce$percent.mt.log=log2(sce$percent.mt+1)
sce$percent.Ribo.log=log2(sce$percent.Ribo+1)


pearplot_after<-VlnPlot_split(sce,group.by ='Samples', 
                              features = c("nCount_RNA.log", "nFeature_RNA.log",
                                           "percent.mt.log",'percent.Ribo.log'),
                              ncols = 4,
                              yname=c('log2(nCount_RNA+1)','log2(nFeature_RNA+1)',
                                      'log2(percent.mt+1)','log2(percent.Ribo+1)'))
pearplot_after

save(datalist,file = 'origin_datas/scRNA/datalist.RData')

summary_cells <- as.data.frame(cbind(raw_count,clean_count))
write.table(summary_cells,'results/ana/01.scRNA/cell_count.txt',quote = F,row.names = T,sep='\t')
#降维
load('origin_datas/scRNA/datalist.RData')
sce <- merge(datalist[[1]],y=datalist[2:length(datalist)])

sce <- NormalizeData(sce, normalization.method = "LogNormalize", scale.factor = 10000)
sce <- FindVariableFeatures(sce, 
                            selection.method = "vst", 
                            nfeatures = 2000,
                            mean.cutoff=c(0.0125,3),
                            dispersion.cutoff =c(1.5,Inf))
sce <- ScaleData(sce, features =  rownames(sce))
sce <- RunPCA(sce, features = VariableFeatures(sce)) 

dimplot <- DimPlot(sce, reduction = "pca",group.by = 'Samples') 
elbowplot <- ElbowPlot(sce, ndims=50, reduction="pca") 
sc_pca <- dimplot+elbowplot
sc_pca

Dims <- 40
sce <- RunUMAP(sce, dims=1:Dims, reduction="pca")
ump.raw<-DimPlot(sce,group.by='Samples',
                 reduction="umap",
                 label = "T", 
                 pt.size = 0.2,
                 label.size = 0)
ump.raw
ggsave('results/ana/01.scRNA/ump.raw.pdf',ump.raw,height = 7,width = 7)

#去批次
# Normalizing the data
load('origin_datas/scRNA/datalist.RData')

for (i in 1:length(datalist)){
  datalist[[i]]<-NormalizeData(datalist[[i]], normalization.method = "LogNormalize", scale.factor = 10000)
  datalist[[i]]<-FindVariableFeatures(datalist[[i]], 
                                      selection.method = "vst", 
                                      nfeatures = 2000,
                                      mean.cutoff=c(0.0125,3),
                                      dispersion.cutoff =c(1.5,Inf))
}

#使用CCA的方法进行剔除批次效应
datalist <- FindIntegrationAnchors(object.list = datalist, dims = 1:40,
                                   reduction = c("cca", "rpca")[1])
sce <- IntegrateData(anchorset = datalist, dims = 1:40)


#ScaleData
DefaultAssay(sce) <- "integrated"

#sce <- NormalizeData(sce, normalization.method = "LogNormalize", scale.factor = 10000)
sce <- FindVariableFeatures(sce, 
                            selection.method = "vst", 
                            nfeatures = 2000,
                            mean.cutoff=c(0.0125,3),
                            dispersion.cutoff =c(1.5,Inf))
sce <- ScaleData(sce, features =  rownames(sce))
sce <- RunPCA(sce, features = VariableFeatures(sce)) 

dimplot <- DimPlot(sce, reduction = "pca",group.by = 'Samples') 
elbowplot <- ElbowPlot(sce, ndims=50, reduction="pca") 
sc_pca <- dimplot+elbowplot
sc_pca

Dims <- 30
sce <- RunUMAP(sce, dims=1:Dims, reduction="pca")
###tsne 降维
sce <- RunTSNE(sce, 
               dims=1:Dims, 
               reduction="pca",
               perplexity=30,
               max_iter=1000)

figs1=mg_merge_plot(Feature_ber,pearplot_befor,sc_pca,
                    nrow = 3,labels = c('A','B','C'),ncol = 1,widths = c(1,1,2))
figs1
ggsave(filename = 'results/ana/01.scRNA/FigS1.pdf',plot = figs1,he=9,width = 10)
ggsave('results/ana/01.scRNA/FigS1.jpg',figs1,height = 9,width = 10,dpi = 300)
saveTiff('results/ana/01.scRNA/FigS1.tif',figs1,height = 9,width = 10)
#聚类
library(clustree)
sce <- FindNeighbors(sce, dims = 1:Dims)
sce <- FindClusters(
  object = sce,
  resolution = c(seq(.1,1,.1))
)
colnames(sce@meta.data)
clustree(sce@meta.data, prefix = "integrated_snn_res.")

pdf('results/ana/01.scRNA/clust.snn_res.pdf',he=15,wi=15)
clustree(sce@meta.data, prefix = "integrated_snn_res.")
dev.off()

#聚类分析
Resolution <- 0.2
sce <- FindNeighbors(object = sce, dims = 1:Dims)
sce <- FindClusters(object = sce, resolution = Resolution)

#亚群注释
DefaultAssay(sce) <- "RNA"
#免疫细胞
VlnPlot(sce,features = c('PTPRC'),pt.size = 0,group.by = 'seurat_clusters')+theme(legend.position = 'none')
#免疫细胞
#T cell:2,7,10
VlnPlot(sce,features = c('CD2','CD3D','CD3E','CD3G'),pt.size = 0,group.by = 'seurat_clusters')
#Macrophage:1,4
VlnPlot(sce,features = c('CD163','CD68','CD14'),pt.size = 0,group.by = 'seurat_clusters')
#Monocyte
VlnPlot(sce,features = c('S100A12','VCAN','FCN1','S100A8'),pt.size = 0,group.by = 'seurat_clusters')
#MDM：单核细胞衍生的巨噬细胞(Monocyte Derived Macrophages):
VlnPlot(sce,features = c('CD68','MNDA','TREM2','CD9','C1QC'),pt.size = 0,group.by = 'seurat_clusters')
#DC
VlnPlot(sce,features = c('CD1A','CD1C','CD1E'),pt.size = 0,group.by = 'seurat_clusters')
#pDC:
VlnPlot(sce,features = c('CD1E','FCER1A','LILRA4'),pt.size = 0,group.by = 'seurat_clusters')
#B cells: 11
VlnPlot(sce,features = c('CD19','CD79A','MS4A1'),pt.size = 0,group.by = 'seurat_clusters')
#Plasma cell:9
VlnPlot(sce,features = c('CD79A','JSRP1'),pt.size = 0,group.by = 'seurat_clusters')
#Mast cell:12
VlnPlot(sce,features = c('TPSAB1','CPA3'),pt.size = 0,group.by = 'seurat_clusters')
#epithelial cells (EPCAM)
VlnPlot(sce,features = 'EPCAM',pt.size = 0,group.by = 'seurat_clusters')
#proliferating cells (MKI67)
VlnPlot(sce,features = 'MKI67',pt.size = 0,group.by = 'seurat_clusters')
#Fibroblast:5
VlnPlot(sce,features = c('ACTA2','FAP','PDGFRB','NOTCH3'),pt.size = 0,group.by = 'seurat_clusters')
#endothelial cells:8
VlnPlot(sce,features = c('PECAM1'),pt.size = 0,group.by = 'seurat_clusters')
#HCC:Hepatocellular carcinoma:0,3,6
VlnPlot(sce,features = c('GPC3','CD24','MDK'),pt.size = 0,group.by = 'seurat_clusters')
#亚群2,7,10为T cell('CD2','CD3D','CD3E','CD3G')，亚群1和4为Macrophage（'CD163','CD68'），亚群11为B cell（'CD19','CD79A','MS4A1'）,亚群9为Plasma cell（'CD79A','JSRP1'），亚群12为Mast cell（'TPSAB1','CPA3'）,亚群5为Fibroblast（'ACTA2','PDGFRB','NOTCH3'）,亚群8为endothelial cell（PECAM1）,亚群0,3,6为Hepatocellular carcinoma（'GPC3','CD24','MDK'）


feat_gene<-c('CD2','CD3D','CD3E','CD3G','CD163','CD68','CD19','CD79A','MS4A1','JSRP1','TPSAB1','CPA3','ACTA2','PDGFRB','NOTCH3','PECAM1','GPC3','CD24','MDK')
cell_anno<-data.frame(seurat_clusters=c('0','1','2','3','4','5','6','7','8','9','10','11','12'),
                      cell_type=c('Hepatocellular carcinoma','Macrophage','T cell','Hepatocellular carcinoma','Macrophage','Fibroblast','Hepatocellular carcinoma','T cell','endothelial cell','Plasma cell','T cell','B cell','Mast cell'))
sce$cell_type<-sce$seurat_clusters
for (i in 1:nrow(cell_anno)){
  sce$cell_type=gsub(paste0('^',cell_anno$seurat_clusters[i],'$'),as.character(cell_anno$cell_type[i]),sce$cell_type)
}

table(sce$cell_type)
length(feat_gene)

#pdf('results/ana/01.scRNA/FigS2.pdf',he=12,width =15)
figs2<-FeaturePlot(sce,
            features = feat_gene,
            pt.size = 0.1,reduction = 'tsne',ncol = 5)

ggsave(filename = 'results/ana/01.scRNA/FigS2.pdf',plot = figs2,he=12,width = 15)
ggsave('results/ana/01.scRNA/FigS2.pdf',figs2,he=12,width = 15,dpi = 300)
saveTiff('results/ana/01.scRNA/FigS2.pdf',figs2,he=12,width = 15)

#marker基因的筛选
#寻找差异基因时的差异倍数
Logfc = 0.5
#差异基因时最小的表达比例
Minpct = 0.35
DefaultAssay(sce) <- "RNA"
Idents(sce)<-'cell_type'
sce.markers <- FindAllMarkers(object = sce,logfc.threshold = Logfc, min.pct = Minpct,only.pos = T)
sce.markers["pct.diff"]=sce.markers$pct.1-sce.markers$pct.2
sce.markers <- sce.markers[sce.markers$p_val_adj<0.05,]
length(unique(sce.markers$gene))
head(sce.markers)
write.table(sce.markers,'results/files/scRNA_marker_gene.txt',quote = F,row.names = F,sep='\t')
write.table(sce.markers,'results/ana/01.scRNA/scRNA_marker_gene.txt',quote = F,row.names = F,sep='\t')

### 选择前5个marker基因
Top5 <- sce.markers %>% group_by(cluster) %>% slice_max(n =5, order_by = avg_logFC)  

Top5 <- intersect(unique(Top5$gene),rownames(sce@assays$RNA@meta.features))

sc_marker_dotplot <- DotPlot(object = sce, features = Top5,cols=c("blue", "red"),scale = T)+ 
  RotatedAxis()+ ggtitle("Top 5 Marker Genes")+ 
  theme(plot.title = element_text(hjust = 0.5)) +xlab('')

sc_marker_dotplot


sc_marker_dotplot<-DoHeatmap(sce, features =Top5,slot='data',group.by = 'cell_type')
sc_marker_dotplot

bubble.df=as.matrix(sce[["RNA"]]@data[Top5,])
bubble.df=t(bubble.df)
bubble.df=as.data.frame(scale(bubble.df))
bubble.df$CB=rownames(bubble.df)
bubble.df=merge(bubble.df,
                data.frame(CB=rownames(sce@meta.data),
                           celltype=sce@meta.data$cell_type),
                by = "CB")
bubble.df$CB=NULL

celltype_v=c()
gene_v=c()
mean_v=c()
ratio_v=c()
for (i in unique(bubble.df$celltype)) {
  bubble.df_small=bubble.df%>%filter(celltype==i)
  for (j in Top5) {
    exp_mean=mean(bubble.df_small[,j])
    exp_ratio=sum(bubble.df_small[,j] > min(bubble.df_small[,j])) / length(bubble.df_small[,j])
    celltype_v=append(celltype_v,i)
    gene_v=append(gene_v,j)
    mean_v=append(mean_v,exp_mean)
    ratio_v=append(ratio_v,exp_ratio)
  }
}
plotdf=data.frame(
  celltype=celltype_v,
  gene=gene_v,
  exp=mean_v,
  ratio=ratio_v)
plotdf$celltype=factor(plotdf$celltype,levels = unique(as.character(sce.markers$cluster)))
plotdf$gene=factor(plotdf$gene,levels = rev(as.character(Top5)))
plotdf$exp=ifelse(plotdf$exp>3,3,plotdf$exp)
sc_marker_dotplot<-plotdf%>%ggplot(aes(x=celltype,y=gene,size=ratio,color=exp))+geom_point()+
  scale_x_discrete("")+scale_y_discrete("")+
  scale_color_gradientn(colours = rev(c("#FFD92F","#FEE391",brewer.pal(11, "Spectral")[7:11])))+
  scale_size_continuous(limits = c(0,1))+theme_bw()+
  theme(
    axis.text.x.bottom = element_text(hjust = 1, vjust = 1, angle = 45)
  )
sc_marker_dotplot
#绘图
library(randomcoloR)
allcolour <- distinctColorPalette(60) 
length(table(sce@active.ident))
mycolor = allcolour[1:length(table(sce$seurat_clusters))]

allcolour=c(ggsci::pal_lancet()(9),ggsci::pal_jco()(9))
load('sce.RData')
colnames(sce@meta.data)
fig1a = DimPlot(sce,cols=allcolour,group.by = 'Samples',
                reduction="tsne",
                label = "F", 
                pt.size = 0.2,
                label.size = 5) +
  theme(axis.line = element_line(size=0.1, colour = "black"), 
        #axis.text = element_blank(), 
        #axis.title = element_blank(),
        axis.ticks = element_blank()
  ) +ggtitle('')+guides(colour = guide_legend(ncol = 1))

fig1a

fig1b<-DimPlot(sce,cols=allcolour,group.by = 'seurat_clusters',
               reduction="tsne",
               label = "F", 
               pt.size = 0.2,
               label.size = 5) +
  theme(axis.line = element_line(size=0.1, colour = "black"), 
        #axis.text = element_blank(), 
        #axis.title = element_blank(),
        axis.ticks = element_blank()
  ) +ggtitle('')
fig1b
fig1c = DimPlot(sce,cols=allcolour,group.by = 'cell_type',
                reduction="tsne",
                label = "F", 
                pt.size = 0.2,
                label.size = 5) +
  theme(axis.line = element_line(size=0.1, colour = "black"), 
        #axis.text = element_blank(), 
        #axis.title = element_blank(),
        axis.ticks = element_blank()
  ) +ggtitle('')
fig1c

fig1abc<-mg_merge_plot(fig1a,fig1b,fig1c,
                       nrow = 1,ncol=3,
                       labels = c('A','B','C'),
                       widths = c(1.2,1,1.3))

summary_cells <- as.data.frame(cbind(raw_count,clean_count))
write.table(summary_cells,'results/ana/01.scRNA/cell_count.txt',quote = F,row.names = T,sep='\t')
table(sce$seurat_clusters)
cell_anno
cell_anno$cell_num=as.data.frame(table(sce$seurat_clusters))[,2]
write.table(cell_anno,'results/ana/01.scRNA/cell_anno.txt',quote = F,row.names = F,sep='\t')

Idents(sce)='seurat_clusters'
library("ggplot2")
sample_clust<-as.matrix(table(sce$Samples,sce$cell_type))
sample_clust=apply(sample_clust,1,function(x){return(x/sum(x))})
sample_clust=reshape2::melt(sample_clust)
colnames(sample_clust)<-c("cluster","Samples","proportion")

clust_freq<-as.data.frame(table(sce$cell_type))
colnames(clust_freq)=c('cluster','cell_num')
clust_freq=clust_freq[order(clust_freq$cell_num,decreasing = T),]
clust_freq$cluster=factor(clust_freq$cluster,levels = clust_freq$cluster)
sample_clust$cluster=factor(sample_clust$cluster,levels =clust_freq$cluster)
write.table(sample_clust,'results/ana/01.scRNA/sample_clust1.txt',quote = F,row.names = T,sep='\t')
sample_clust$cluster=as.factor(sample_clust$cluster)
sample_clust$proportion=round(sample_clust$proportion,4)

fig1e1<-ggplot(sample_clust,aes(x = cluster,y = proportion,fill=Samples))+
  geom_bar(stat = "identity", position = "fill") +
  ggtitle("") +
  theme_bw() + 
  theme(axis.ticks.length = unit(0.1, 'cm'),
        legend.position = "left") +xlab('')+
  coord_flip()+scale_y_continuous(expand = expand_scale(mult = c(0, 0)))
#geom_text(aes(label = proportion),position=position_stack(vjust =0.5),size = 2)
fig1e1

fig1e2<-ggplot(clust_freq,aes(x = cluster,y = cell_num))+
  geom_bar(stat="identity",fill='green')+ggtitle("") +
  theme_bw() + 
  theme(axis.ticks.length = unit(0, 'cm'),
        axis.text.y = element_blank(),
        axis.title.y = element_blank()) +coord_flip()+
  scale_y_continuous(expand = expand_scale(mult = c(0, 0)))+ylim(0,max(clust_freq$cell_num)+10)
fig1e2

fig1e3<-ggpubr::ggarrange(fig1e1,fig1e2,nrow = 1,ncol = 2,widths = c(2,1))
fig1e3
#细胞衰老相关通路的富集得分
library(clusterProfiler)
cellage.pathway<-clusterProfiler::read.gmt('origin_datas/cellAge.pathway.gmt')
write.table(cellage.pathway,'results/ana/01.scRNA/cellage.pathway.txt',quote = F,row.names = F,sep='\t')
write.table(cellage.pathway,'results/files/pathway.txt',quote = F,row.names = F,sep='\t')
ssGSEAScore_by_genes=function(gene.exp,genes){
  #library('GSVA')
  #library(GSEABase)
  #all.list=list()
  gs=GSEABase::GeneSet(setName='GeneSet', setIdentifier=paste0("101"),geneIds=unique(genes),GSEABase::SymbolIdentifier()) 
  
  gsc <- GSEABase::GeneSetCollection(list(gs))
  fl <- tempfile()
  GSEABase::toGmt(gsc, fl)
  cgeneset=GSEABase::getGmt(fl)
  ssGSEA.geneset <- GSVA::gsva(as.matrix(gene.exp), cgeneset,method='ssgsea',
                               min.sz=1, max.sz=5000, verbose=TRUE)
  #detach('package:GSVA')
  #detach('package:GSEABase')
  #row.names(ssGSEA.geneset)
  return(ssGSEA.geneset)
}
as.character(unique(cellage.pathway$ont))

cellage.pathway.score<-data.frame()
exp=as.matrix(sce@assays$RNA@counts)
for (i in as.character(unique(cellage.pathway$ont))){
  path1=cellage.pathway[cellage.pathway$ont==i,]
  score=ssGSEAScore_by_genes(gene.exp = exp,genes=path1$gene)
  rownames(score)=i
  cellage.pathway.score=rbind.data.frame(cellage.pathway.score,score)
}
rm(exp)
cellage.pathway.score=t(cellage.pathway.score)

#cnv分析
save(sce,file = 'sce.RData')
# load('sce.RData')
# library(copykat)
# source('/pub1/data/mg_projects/users/wangtl/public/copykat.R')
# copykat.test <- copykat(rawmat=sce@assays$RNA@counts,
#                         id.type="S",
#                         cell.line="no",
#                         ngene.chr=5,
#                         #每个染色体中至少有 5 个基因来计算 DNA 拷贝数
#                         win.size=25,
#                         #每个片段至少取 25 个基因
#                         KS.cut=0.15,
#                         #0-1,值越大灵敏度越低
#                         sam.name="LIHC",
#                         #随意固定一个名称
#                         distance="euclidean",
#                         n.cores=30
#                         #并行计算
# )
# save(copykat.test,file = 'copykat.test.RData')

head(cellage.pathway.score)
#读取CNV的结果
copykat.test<-read.delim('LIHC_copykat_prediction.txt',sep='\t',header = T)
head(copykat.test)
table(copykat.test$copykat.pred)
rownames(copykat.test)=copykat.test$cell.names
copykat.test=copykat.test[rownames(sce@meta.data),]
#添加分组
sce <- AddMetaData(sce, copykat.test$copykat.pred,col.name = "copykat.pred")
sce$copykat.pred[is.na(sce$copykat.pred)]<-'Unknown'
table(sce$copykat.pred)
# aneuploid   diploid 
# 9505     20985
fig1f<- DimPlot(sce,cols=mycolor,group.by = 'copykat.pred',
                reduction="tsne",
                label = "F", 
                pt.size = 0.2,
                label.size = 5) +
  theme(axis.line = element_line(size=0.1, colour = "black"), 
        #axis.text = element_blank(), 
        #axis.title = element_blank(),
        axis.ticks = element_blank()
  ) +ggtitle('')
#各个样本中cnv预测的肿瘤和正常的比例
sample_clust1<-as.matrix(table(sce$Samples,sce$copykat.pred))
sample_clust1=apply(sample_clust1,1,function(x){return(x/sum(x))})
sample_clust1=reshape2::melt(sample_clust1)

colnames(sample_clust1)<-c("copykat.pred","Patient","proportion")
write.table(sample_clust1,'results/ana/01.scRNA/copykat.pred_sample.txt',quote = F,row.names = T,sep='\t')

fig1g<-ggplot(sample_clust1,aes(x = Patient,y = proportion,fill=copykat.pred))+
  geom_bar(stat = "identity", position = "fill") +
  ggtitle("") +
  theme_bw() + 
  theme(axis.ticks.length = unit(0.1, 'cm'),
        legend.position = "right") +xlab('')+
  scale_y_continuous(expand = expand_scale(mult = c(0, 0)))
fig1g

fig1ef<-mg_merge_plot(fig1e3,fig1f,labels = c('E','F'),nrow = 1,ncol = 2,widths = c(1.5,1))
fig1=mg_merge_plot(fig1abc,sc_marker_dotplot,fig1ef,nrow = 3,ncol = 1,heights = c(1,1.8,1),labels = c('','D',''))
ggsave(filename = 'results/ana/01.scRNA/Fig1.pdf',plot = fig1,he=15,wi=18)


cellage.pathway.score.group<-merge(data.frame(cell.names=rownames(sce@meta.data),
                                              cell_type=sce@meta.data$cell_type,
                                              copykat.pred=sce@meta.data$copykat.pred),
                                   data.frame(cell.names=rownames(cellage.pathway.score),
                                              cellage.pathway.score),
                                   by='cell.names')
rownames(cellage.pathway.score.group)=cellage.pathway.score.group$cell.names
cellage.pathway.score.group=cellage.pathway.score.group[,-1]
head(cellage.pathway.score.group)
cellage.pathway.score.group.mean=data.frame()
for (i in c('aneuploid','diploid')){
  cellage.pathway.score.group1=cellage.pathway.score.group[cellage.pathway.score.group$copykat.pred==i,-2]
  cellage.pathway.score.group.mean1=aggregate(.~cell_type,data=cellage.pathway.score.group1,mean)
  cellage.pathway.score.group.mean1$copykat.pred=i
  cellage.pathway.score.group.mean=rbind.data.frame(cellage.pathway.score.group.mean,cellage.pathway.score.group.mean1)
}
head(cellage.pathway.score.group.mean)
table(cellage.pathway.score.group.mean$copykat.pred)

library(pheatmap)
library(ComplexHeatmap)
library(circlize)

#Z-score
colnames(cellage.pathway.score.group.mean)
cellage.pathway.score.group.mean1=apply(cellage.pathway.score.group.mean[,3:19],2,function(x){return(mosaic::zscore(x))})
cellage.pathway.score.group.mean=data.frame(cell_type=cellage.pathway.score.group.mean$cell_type,
                                            copykat.pred=cellage.pathway.score.group.mean$copykat.pred,
                                            cellage.pathway.score.group.mean1)


#aneuploid
mat1=cellage.pathway.score.group.mean[cellage.pathway.score.group.mean$copykat.pred=='aneuploid',]
rownames(mat1)=mat1$cell_type
col_anno <-HeatmapAnnotation(copykat.pred= mat1$copykat.pred)
names(col_anno)='aneuploid'

mat1=as.matrix(mat1[,c(as.character(unique(cellage.pathway$ont)))])

mean_value=apply(mat1,1,function(x){return(mean(x))})
range(mean_value)
bar = HeatmapAnnotation(barplot = anno_barplot(x = as.numeric(mean_value),
                                               border = F, 
                                               axis = TRUE,
                                               gp = gpar(fill = "green",
                                                         col = "white"),
                                               bar_with = 0.8,
                                               baseline=0,ylim = c(-1.5,2)))

p1= Heatmap(matrix = t(mat1),
            name="GSVA score",
            cluster_columns = F,
            cluster_rows = F,top_annotation = bar,
            #left_annotation= sam_ann,
            col = colorRamp2(c(-2,0,2), c("blue", "white", "red")),
            show_column_names = T,
            show_row_names = F,show_heatmap_legend = F,
            bottom_annotation = col_anno, 
            show_row_dend = F)
p1
#diploid
mat2=cellage.pathway.score.group.mean[cellage.pathway.score.group.mean$copykat.pred=='diploid',]
rownames(mat2)=mat2$cell_type
col_anno <-HeatmapAnnotation(copykat.pred= mat2$copykat.pred)
names(col_anno)='diploid'

mat2=as.matrix(mat2[,c(as.character(unique(cellage.pathway$ont)))])
mean_value=apply(mat2,1,function(x){return(mean(x))})
range(mean_value)
bar = HeatmapAnnotation(barplot = anno_barplot(x = as.numeric(mean_value),
                                               border = F, 
                                               axis = TRUE,
                                               gp = gpar(fill = "green",
                                                         col = "white"),
                                               bar_with = 0.8,
                                               baseline=0,ylim = c(-1.5,2)))


p2= Heatmap(matrix = t(mat2),
            name="Row Z-score GSVA score",
            cluster_columns = F,
            cluster_rows = F,top_annotation = bar,
            col = colorRamp2(c(-2,0,2), c("blue", "white", "red")),
            show_column_names = T,
            show_row_names = T,show_heatmap_legend = T,
            bottom_annotation  = col_anno, 
            show_row_dend = T)
p2
fig2<-p1+p2
fig2
pdf('results/ana/01.scRNA/Fig2.pdf',height = 7,width = 12)
print(fig2)
dev.off()
save(sce,file = 'sce.RData')
rm(sce,datalist)
save.image('project_001.RData')
##第二部分#####################
setwd('/pub1/data/mg_projects/users/wangtl/202201/20220811_LIHC.cellAge.scRNA')
options(stringsAsFactors = F)
source('/pub1/data/mg_projects/projects/codes/mg_base.R')
#2、Bulk-Seq数据的准备####
dir.create('results/ana/02.data.pre')
#2.1 tcga ####
tcga_cli<-read.delim('origin_datas/TCGA/Merge_LIHC_clinical.txt',sep='\t',header = T,check.names = F)
tcga_cli=data.frame(Samples=tcga_cli$A0_Samples,
                    Age=tcga_cli$A17_Age,
                    Grade=tcga_cli$A7_Grade,
                    Gender=tcga_cli$A18_Sex,
                    T.Stage=tcga_cli$A3_T,
                    N.Stage=tcga_cli$A4_N,
                    M.Stage=tcga_cli$A5_M,
                    Stage=tcga_cli$A6_Stage,
                    OS=tcga_cli$A2_Event,
                    OS.time=tcga_cli$A1_OS)
head(tcga_cli)
rownames(tcga_cli)=tcga_cli$Samples
tcga_cli=crbind2DataFrame(tcga_cli)
fivenum(tcga_cli$Age)
tcga_cli$Age1=ifelse(tcga_cli$Age>60,'>60','<=60')
table(tcga_cli$Gender)

table(tcga_cli$T.Stage)
tcga_cli$T.Stage=gsub('[abc]','',tcga_cli$T.Stage)
tcga_cli$T.Stage[tcga_cli$T.Stage==''|tcga_cli$T.Stage=='TX'|tcga_cli$T.Stage=='Tis']<-NA

table(tcga_cli$N.Stage)
tcga_cli$N.Stage=gsub('[abc]','',tcga_cli$N.Stage)
tcga_cli$N.Stage[tcga_cli$N.Stage==''|tcga_cli$N.Stage=='NX']<-NA

table(tcga_cli$M.Stage)
tcga_cli$M.Stage=gsub('[abc]','',tcga_cli$M.Stage)
tcga_cli$M.Stage[tcga_cli$M.Stage==''|tcga_cli$M.Stage=='MX']<-NA

table(tcga_cli$Stage)
tcga_cli$Stage=gsub('Stage ','',tcga_cli$Stage)
tcga_cli$Stage=gsub('[ABC]','',tcga_cli$Stage)
tcga_cli$Stage[tcga_cli$Stage=='']<-NA

table(tcga_cli$Grade)
tcga_cli$Grade[tcga_cli$Grade=='Not Available']<-NA

table(tcga_cli$OS)
tcga_cli$OS=ifelse(tcga_cli$OS=='Alive',0,ifelse(tcga_cli$OS=='Dead',1,NA))

tcga_cli$Samples=paste0(tcga_cli$Samples,'-01')
rownames(tcga_cli)=tcga_cli$Samples
#去掉NA
library(tidyr)
tcga_cli <- tcga_cli %>% drop_na(OS.time)

tcga_cli=tcga_cli[tcga_cli$OS.time>0,]
#表达谱
tcga_tmp<-read.delim('origin_datas/TCGA/Merge_TCGA-LIHC_TPM.txt',sep='\t',header = T,row.names = 1,check.names = F)
rownames(tcga_tmp)[1:6]
#肿瘤样本和正常样本
sample_T<-colnames(tcga_tmp)[substr(colnames(tcga_tmp),14,15)=='01']
sample_T=intersect(sample_T,tcga_cli$Samples)
length(sample_T)
#365
sample_N=colnames(tcga_tmp)[substr(colnames(tcga_tmp),14,15)=='11']
length(sample_N)#50
gene.type<-read.delim('/pub1/data/mg_projects/users/wangtl/public/GeneTag.genecode.v32.txt',sep='\t',header = T)
table(gene.type$TYPE)
gene.type=gene.type[which(gene.type$TYPE=='protein_coding'),'SYMBOL']
tcga_tmp=tcga_tmp[intersect(rownames(tcga_tmp),gene.type),]


tcga_tmp_log2<-log2(tcga_tmp[,c(sample_N,sample_T)]+1)
tcga_tmp_log2_T<-tcga_tmp_log2[,sample_T]
tcga_cli=tcga_cli[sample_T,]
tcga.group=rbind.data.frame(data.frame(Samples=sample_T,Type='Tumor'),
                            data.frame(Samples=sample_N,Type='Normal'))

write.table(tcga.group,'results/ana/02.data.pre/tcga.group.txt',quote = F,row.names = F,sep='\t')
write.table(tcga_tmp_log2,'results/ana/02.data.pre/tcga_tpm_log.txt',quote = F,row.names = T,sep='\t')
write.table(tcga_cli,'results/ana/02.data.pre/tcga_cli.txt',quote = F,row.names = F,sep='\t')
write.table(tcga_tmp_log2_T,'results/ana/02.data.pre/tcga_tmp_log2_T.txt',quote = F,row.names = T,sep='\t')

dim(tcga_tmp_log2)
#19160   415
#2.2 HCCDB18 数据准备#####
HCCDB18_exp<-read.delim('origin_datas/GEO/HCCDB18_mRNA_level3.txt',sep='\t',header = T,check.names = F)
HCCDB18_exp[1:4,1:4]
HCCDB18_exp=HCCDB18_exp[,-1]
HCCDB18_exp=aggregate(.~Symbol,HCCDB18_exp,mean)
rownames(HCCDB18_exp)=HCCDB18_exp$Symbol
HCCDB18_exp[1:4,1:4]
HCCDB18_exp=HCCDB18_exp[,-1]
#sample
HCCDB18_sample=read.delim('origin_datas/GEO/HCCDB18.sample.txt',sep='\t',header = T,row.names = 1,check.names = F)
HCCDB18_sample[,1:4]

HCCDB18_sample=data.frame(patientid=as.character(HCCDB18_sample[4,]),
                          Samples=colnames(HCCDB18_sample),
                          type=as.character(HCCDB18_sample[1,]))
head(HCCDB18_sample)
HCCDB18_sample=HCCDB18_sample[which(HCCDB18_sample$type=='HCC'),]

HCCDB18_cli1=read.delim('origin_datas/GEO/HCCDB18.patient.txt',sep='\t',header = T,check.names = F,row.names = 1)
HCCDB18_cli=t(HCCDB18_cli1)
HCCDB18_cli[1:4,1:4]
HCCDB18_cli=crbind2DataFrame(HCCDB18_cli)
intersect(HCCDB18_sample$patientid,rownames(HCCDB18_cli))
HCCDB18_cli111=merge(HCCDB18_sample,
                     data.frame(patientid=rownames(HCCDB18_cli),HCCDB18_cli),
                     by='patientid')
HCCDB18_cli111[1:4,1:4]

HCCDB18_cli=data.frame(Samples=HCCDB18_cli111$Samples,
                       OS=HCCDB18_cli111$STATUS,
                       OS.time=HCCDB18_cli111$SUR*30,
                       Gender=HCCDB18_cli111$GENDER,
                       Age=HCCDB18_cli111$AGE,
                       Virus=HCCDB18_cli111$VIRUS,
                       T.Stage=HCCDB18_cli111$TNM_STAGE_T,
                       Stage=HCCDB18_cli111$TNM_STAGE_T1,
                       Smoking=HCCDB18_cli111$SMOKING)
head(HCCDB18_cli)
HCCDB18_cli=crbind2DataFrame(HCCDB18_cli)

HCCDB18_cli$OS=gsub('Alive',0,HCCDB18_cli$OS)
HCCDB18_cli$OS=gsub('Dead',1,HCCDB18_cli$OS)
rownames(HCCDB18_cli)=HCCDB18_cli$Samples
head(HCCDB18_cli)
HCCDB18_cli$T.Stage=paste0('T',HCCDB18_cli$T.Stage)

table(HCCDB18_cli$Gender)

fivenum(HCCDB18_cli$Age)
HCCDB18_cli$Age1=ifelse(HCCDB18_cli$Age>60,'>60','<=60')

table(HCCDB18_cli$T.Stage)

table(HCCDB18_cli$Stage)

table(HCCDB18_cli$Smoking)


hccd_sample=intersect(colnames(HCCDB18_exp),HCCDB18_cli$Samples)
HCCDB18_exp=HCCDB18_exp[,hccd_sample]
HCCDB18_cli=HCCDB18_cli[hccd_sample,]
dim(HCCDB18_exp)
range(HCCDB18_exp)
#21362   389
dim(HCCDB18_cli)
rownames(HCCDB18_cli)=HCCDB18_cli$Samples
HCCDB18_cli=crbind2DataFrame(HCCDB18_cli)
write.table(HCCDB18_exp,'results/ana/02.data.pre/HCCDB18_exp.txt',quote = F,row.names = T,sep='\t')
write.table(HCCDB18_cli,'results/ana/02.data.pre/HCCDB18_cli.txt',quote = F,row.names = F,sep='\t')
#2.3 GSE14520数据集准备####
#GSE14520=getGEOExpData('GSE14520')
#save(GSE14520,file='origin_datas/GEO/GSE14520.RData')
load('origin_datas/GEO/GSE14520.RData')
GSE14520_exp1<-GSE14520$Exp$GPL571_22268_Data_col1
gene_anno1<-GSE14520$Anno$GPL571[,c(1,11)]
gene_anno1[,3]=stringr::str_split_fixed(gene_anno1$V11,' /// ',3)[,2]
gene_anno1=gene_anno1[which(gene_anno1$V3==''),c(1,2)]
GSE14520_exp1=exp_probe2symbol_v2(GSE14520_exp1,gene_anno1)

GSE14520_exp2<-GSE14520$Exp$GPL3921_22268_Data_col1
gene_anno2<-GSE14520$Anno$GPL3921[,c(1,11)]
gene_anno2[,3]=stringr::str_split_fixed(gene_anno2$V11,' /// ',3)[,2]
gene_anno2=gene_anno2[which(gene_anno2$V3==''),c(1,2)]
GSE14520_exp2=exp_probe2symbol_v2(GSE14520_exp2,gene_anno2)

intersect(colnames(GSE14520_exp1),colnames(GSE14520_exp2))
geo_com=intersect(rownames(GSE14520_exp1),rownames(GSE14520_exp2))
GSE14520_exp=cbind(GSE14520_exp1[geo_com,],GSE14520_exp2[geo_com,])
dim(GSE14520_exp)
#10501   488
range(GSE14520_exp)

GSE14520_cli=read.delim('origin_datas/GEO/GSE14520_Extra_Supplement.txt',sep='\t',header = T,check.names = F)
GSE14520_cli=data.frame(Samples=GSE14520_cli$Affy_GSM,
                        OS=GSE14520_cli$`Survival status`,
                        OS.time=GSE14520_cli$`Survival months`*30,
                        Gender=GSE14520_cli$Gender,
                        Age=GSE14520_cli$Age,
                        HBV=GSE14520_cli$`HBV viral status`,
                        Stage=GSE14520_cli$`TNM staging`,
                        RFS=GSE14520_cli$`Recurr status`,
                        RFS.time=GSE14520_cli$`Recurr months`*30)
GSE14520_cli$OS

table(GSE14520_cli$HBV)
GSE14520_cli$HBV[GSE14520_cli$HBV=='-']<-NA

table(GSE14520_cli$Stage)
GSE14520_cli$Stage=gsub('[ABC]','',GSE14520_cli$Stage)
GSE14520_cli$Stage[GSE14520_cli$Stage=='-']<-NA

dim(GSE14520_cli)
rownames(GSE14520_cli)=GSE14520_cli$Samples
com_sam<-intersect(colnames(GSE14520_exp),GSE14520_cli$Samples)
length(com_sam)
GSE14520_exp=GSE14520_exp[,com_sam]
GSE14520_cli=GSE14520_cli[com_sam,]
write.table(GSE14520_exp,'results/ana/02.data.pre/GSE14520_exp.txt',quote = F,row.names = T,sep='\t')
write.table(GSE14520_cli,'results/ana/02.data.pre/GSE14520_cli.txt',quote = F,row.names = F,sep='\t')
#2.4 GSE76427 数据集准备####
#GSE76427=getGEOExpData('GSE76427')
#save(GSE76427,file='origin_datas/GEO/GSE76427.RData')
load('origin_datas/GEO/GSE76427.RData')

gene_anno2=GSE76427$Anno$GPL10558[,c(1,12,13)]
head(gene_anno2)
gene_anno2=gene_anno2[which(gene_anno2$V12!=''),]


library(lumi) 
gse.lumi <- lumiR.batch('origin_datas/GEO/GSE76427_non-normalized.txt.gz')
lumi.N.Q <- lumiExpresso(gse.lumi)
GSE76427_exp <- exprs(lumi.N.Q)
GSE76427_exp=exp_probe2symbol_v2(GSE76427_exp,gene_anno2[,c(1,3)])
GSE76427_exp[1:4,1:4]
range(GSE76427_exp)

GSE76427_cli=GSE76427$Sample
GSE76427_cli=data.frame(Samples=GSE76427_cli$Desc,
                        OS=GSE76427_cli$event_os,
                        OS.time=GSE76427_cli$duryears_os,
                        RFS=GSE76427_cli$event_rfs,
                        RFS.time=GSE76427_cli$duryears_rfs,
                        Age=GSE76427_cli$`age (years)`,
                        Gender=GSE76427_cli$`gender (1=m, 2=f)`,
                        Stage=GSE76427_cli$tnm_staging_clinical)
GSE76427_cli$Samples=gsub('Sample name: ','',GSE76427_cli$Samples)
GSE76427_cli=GSE76427_cli[which(GSE76427_cli$OS!='NULL'),]
GSE76427_cli=crbind2DataFrame(GSE76427_cli)
GSE76427_cli$OS.time=ceiling(GSE76427_cli$OS.time*365)
GSE76427_cli$RFS.time=ceiling(GSE76427_cli$RFS.time*365)
table(GSE76427_cli$OS)
table(GSE76427_cli$RFS)
table(GSE76427_cli$Gender)
GSE76427_cli$Gender=ifelse(GSE76427_cli$Gender==1,'Male','Female')
table(GSE76427_cli$Stage)
GSE76427_cli$Stage[GSE76427_cli$Stage=='NA']<-NA
GSE76427_cli$Stage=gsub('[ABC]','',GSE76427_cli$Stage)
rownames(GSE76427_cli)=GSE76427_cli$Samples
com_sam<-intersect(GSE76427_cli$Samples,colnames(GSE76427_exp))
com_sam
GSE76427_cli=GSE76427_cli[com_sam,]
GSE76427_exp=GSE76427_exp[,com_sam]
range(GSE76427_exp)
dim(GSE76427_exp)
#31425   115
write.table(GSE76427_exp,'results/ana/02.data.pre/GSE76427_exp.txt',quote = F,row.names = T,sep='\t')
write.table(GSE76427_cli,'results/ana/02.data.pre/GSE76427_cli.txt',quote = F,row.names = F,sep='\t')

#3、细胞衰老相关通路在肿瘤和正常组织中的GSEA分析#########
dir.create('results/ana/03.GSEA/TCGA',recursive = T)
dim(tcga_tmp_log2)
head(tcga.group)
writeMatrix(dat = tcga_tmp_log2[,tcga.group$Samples],outpath = 'results/ana/03.GSEA/tcga_tmp_log2.txt',row = T,header = T)
writeMatrix(dat = tcga.group,outpath = 'results/ana/03.GSEA/tcga.group.txt',row = F,header = T)

mg_RunGSEA_wtl<-function(mod=c('exp_group','exp_gene','rank')[1],exp_Path=NULL, sample_group_path=NULL, outFolder=NULL,gene=NULL, column=NULL,lower=50,upper=50, gmt_Path=c("KEGG",'GO_BP','GO_CC','GO_MF','reactome','HALLMARK','TF','other')[1],plot_svg=FALSE,top=10,min=5,max=5000,outLog=T,gmt_Path1){
  
  if(is.null(exp_Path)|is.null(mod)|is.null(outFolder)|is.null(gmt_Path)){
    return(NULL)
  }
  if(plot_svg){
    svg='true'
  }else{
    svg='false'
  }
  if(gmt_Path=='KEGG'){
    gmt_Path=paste0(MG_Grobal_baseFolder,'/source/c2.cp.kegg.v7.0.symbols.gmt')
  }
  else if(gmt_Path=='GO_BP'){
    gmt_Path=paste0(MG_Grobal_baseFolder,'/source/c5.bp.v7.0.symbols.gmt')
  }
  else if(gmt_Path=='GO_CC'){
    gmt_Path=paste0(MG_Grobal_baseFolder,'/source/c5.cc.v7.0.symbols.gmt')
  }
  else if(gmt_Path=='GO_MF'){
    gmt_Path=paste0(MG_Grobal_baseFolder,'/source/c5.mf.v7.0.symbols.gmt')
  }
  else if(gmt_Path=='reactome'){
    gmt_Path=paste0(MG_Grobal_baseFolder,'/source/c2.cp.reactome.v7.0.symbols.gmt')
  }
  else if(gmt_Path=='HALLMARK'){
    gmt_Path=paste0(MG_Grobal_baseFolder,'/source/h.all.v7.0.symbols.gmt')
  }
  else if(gmt_Path=='TF'){
    gmt_Path=paste0(MG_Grobal_baseFolder,'/source/c3.tft.v7.0.symbols.gmt')
  }else if(gmt_Path=='other'){
    gmt_Path=gmt_Path1
  }
  if(file.exists(paste0(getwd(),'/',outFolder))){
    outFolder=paste0(getwd(),'/',outFolder)
  }else if(!file.exists(outFolder)){
    dir.create(outFolder)
    if(file.exists(paste0(getwd(),'/',outFolder))){
      outFolder=paste0(getwd(),'/',outFolder)
    }
  }
  
  if(file.exists(paste0(getwd(),'/',gmt_Path))){
    gmt_Path=paste0(getwd(),'/',gmt_Path)
  }
  if(file.exists(paste0(getwd(),'/',exp_Path))){
    exp_Path=paste0(getwd(),'/',exp_Path)
  }
  
  command=NULL
  if(mod=='exp_group'){
    if(!is.null(exp_Path)&!is.null(sample_group_path)&!is.null(outFolder)){
      if(file.exists(paste0(getwd(),'/',sample_group_path))){
        sample_group_path=paste0(getwd(),'/',sample_group_path)
      }
      command=paste0(MG_Grobal_baseFolder,'/jre/GSEA/MG_GSEA.jar exp_group '
                     ,exp_Path,' ',sample_group_path,' ',outFolder,' ',gmt_Path,' ',svg,' ',top,' ',min,' ',max) 
    }
  }else if(mod=='exp_gene'){
    if(!is.null(exp_Path)&!is.null(gene)&!is.null(outFolder)){
      command=paste0(MG_Grobal_baseFolder,'/jre/GSEA/MG_GSEA.jar exp_gene '
                     ,exp_Path,' ',gene,' ',outFolder,' ',gmt_Path,' ',svg,' ',top,' ',min,' ',max,' ',lower,' ',upper) 
    }
  }else if(mod=='rank'){
    if(!is.null(exp_Path)&!is.null(column)&!is.null(outFolder)){
      command=paste0(MG_Grobal_baseFolder,'/jre/GSEA/MG_GSEA.jar rank '
                     ,exp_Path,' ',column-1,' ',outFolder,' ',gmt_Path,' ',svg,' ',top,' ',min,' ',max) 
    }
  }
  
  if(!is.null(command)){
    if(MG_Grobal_System=='win'){
      command=paste0(MG_Grobal_baseFolder,'/jre/bin/java -jar ',command)
    }else{
      command=paste0('java -jar ',command)
    }
    print(paste0('RunGSEA CMD:',command))
    logs=system(command, intern = !outLog, 
                ignore.stdout = FALSE, ignore.stderr = FALSE, 
                wait = TRUE, input = NULL, show.output.on.console = TRUE, 
                minimized = FALSE, invisible = TRUE)
    if(outLog){
      if(logs==0){
        print('Run GSEA succ')
      }else{
        print('Run GSEA error')
      }
    }else{
      print('Runed GSEA')
      print(logs)
      logs=logs[grep('######/',logs)]
      if(length(logs)==1){
        logs=unlist(strsplit(logs[1],'/'))
        if(length(logs)>1){
          return(logs[2:length(logs)])
        }
      }
    }
  }
  return(NULL)
}
#TCGA
mg_RunGSEA_wtl(mod = 'exp_group',exp_Path = 'results/ana/03.GSEA/tcga_tmp_log2.txt'
               ,sample_group_path = 'results/ana/03.GSEA/tcga.group.txt'
               ,outFolder = 'results/ana/03.GSEA/TCGA/'
               ,gmt_Path = 'other',outLog=F,gmt_Path1=paste0(getwd(),'/origin_datas/cellAge.pathway.gmt'))
#结果读取
tcga_GSEA=parseGSEAResult('results/ana/03.GSEA/TCGA/my_analysis.Gsea.1660268919370/')

tcga.sig<-tcga_GSEA$EnrichTable[tcga_GSEA$EnrichTable$NP<0.05,"Term"]
length(tcga.sig)
sig_pathway=tcga.sig
tcga.sig
tcga.plot1<-plot_GSEA_By_nodes(tcga_GSEA,TermNames = tcga.sig)
tcga.plot1

#ggsave('results/ana/03.GSEA/fig3a.pdf',tcga.plot1,height = 7,width = 10)
#4、细胞衰老相关通路在肿瘤和正常组织中的ssGSEA分析####
ssGSEAScore_by_genes=function(gene.exp,genes){
  #library('GSVA')
  #library(GSEABase)
  #all.list=list()
  gs=GSEABase::GeneSet(setName='GeneSet', setIdentifier=paste0("101"),geneIds=unique(genes),GSEABase::SymbolIdentifier()) 
  
  gsc <- GSEABase::GeneSetCollection(list(gs))
  fl <- tempfile()
  GSEABase::toGmt(gsc, fl)
  cgeneset=GSEABase::getGmt(fl)
  ssGSEA.geneset <- GSVA::gsva(as.matrix(gene.exp), cgeneset,method='ssgsea',
                               min.sz=1, max.sz=5000, verbose=TRUE)
  #detach('package:GSVA')
  #detach('package:GSEABase')
  #row.names(ssGSEA.geneset)
  return(ssGSEA.geneset)
}
pathway.score<-function(exp,gene){
  pathway_score<-data.frame()
  for (i in unique(gene[,1])){
    print(i)
    gene_set=gene[gene[,1]==i,"gene"]
    score=ssGSEAScore_by_genes(exp,gene_set)
    rownames(score)=i
    pathway_score=rbind.data.frame(pathway_score,score)
  }
  return(t(pathway_score))
}

cellage.pathway<-clusterProfiler::read.gmt('origin_datas/cellAge.pathway.gmt')
as.character(unique(cellage.pathway$ont))
table(cellage.pathway$ont)
table(cellage.pathway$gene)
#TCGA数据集ssGSEA分析
tcga.cellage.score<-pathway.score(exp=tcga_tmp_log2,gene = cellage.pathway)
write.table(tcga.cellage.score,'results/ana/03.GSEA/tcga.cellage.score.txt',quote = F,row.names = T,sep='\t')
write.table(tcga.cellage.score,'results/files/tcga.cellage.score.txt',quote = F,row.names = T,sep='\t')

#差异分析
diff_gene1<-function(dat,group){
  dat=data.frame(cluster=group,t(dat))
  gr=as.character(unique(group))
  dat1=t(dat[dat$cluster==gr[1],-1])
  dat2=t(dat[dat$cluster==gr[2],-1])
  #dat3=t(dat[dat$cluster==gr[3],-1])
  #pathway=unique(c(rownames(dat1),rownames(dat2),rownames(dat3)))
  pathway=unique(c(rownames(dat1),rownames(dat2)))
  p_vale=data.frame()
  for (i in pathway){
    # d1=c(as.numeric(dat1[i,]),
    #      as.numeric(dat2[i,])
    #      #,as.numeric(dat3[i,])
    #      )
    # d2=factor(c(rep('A',ncol(dat1)),
    #             rep('B',ncol(dat2))
    #             #,rep('C',ncol(dat3)))
    #             ))
    dd1=wilcox.test(as.numeric(dat1[i,]),as.numeric(dat2[i,]))$p.value
    #logfc=log2(mean(dat1[i,])/mean(dat2[i,]))
    p_vale=rbind.data.frame(p_vale,data.frame(gene=i,p.value=dd1
                                              #,logfc=logfc
    ))
  }
  return(p_vale)
}

tcga.pathway.p<-diff_gene1(dat=t(tcga.cellage.score[tcga.group$Samples,]),
                           group=tcga.group$Type)

tcga.pathway.p$lab=ifelse(tcga.pathway.p$p.value<0.001,'***',ifelse(tcga.pathway.p$p.value<0.01,'**',ifelse(tcga.pathway.p$p.value<0.05,'*','')))

write.table(tcga.pathway.p,'results/ana/03.GSEA/tcga.pathway.p.txt',quote = F,row.names = F,sep='\t')

tcga.heat<-t(tcga.cellage.score)[tcga.pathway.p$gene,]
rownames(tcga.heat)=paste0(tcga.pathway.p$gene,tcga.pathway.p$lab)

#注释
tcga.anno<-data.frame(Type=tcga.group$Type)
rownames(tcga.anno)=tcga.group$Samples
tcga.anno=tcga.anno[order(tcga.anno$Type),,drop=F]


fig3c<-pheatmap::pheatmap(tcga.heat[,rownames(tcga.anno)],
                          scale = 'row',
                          show_colnames = F,annotation_col = tcga.anno,cluster_cols = F,cluster_rows =T,
                          color = colorRampPalette(c("blue", "white","red"))(100),
                          annotation_names_row = F,
                          breaks = unique(c(seq(-1, 1, length=100))))
fig3c <- ggplotify::as.ggplot(fig3c)
fig3<-mg_merge_plot(tcga.plot1,fig3c,nrow = 2,ncol = 1,labels = c('A','B'))
ggsave('results/ana/03.GSEA/Fig3.pdf',fig3,height = 10,width = 12)
#5、衰老相关分子亚型的构建####
#Senescence Subtype
dir.create('results/ana/04.subtype')
sig_pathway=tcga.sig
sig_pathway
sig_gene=unique(cellage.pathway[cellage.pathway$ont %in% sig_pathway,"gene"])
length(sig_gene)#253
#
sig_gene=intersect(sig_gene,rownames(tcga_tmp_log2))
length(sig_gene)#186

#TCGA
tcga_cellage.exp<-tcga_tmp_log2[sig_gene,tcga_cli$Samples]
dim(tcga_cellage.exp)
write.table(tcga_cellage.exp,'results/ana/04.subtype/tcga_cellage.exp.txt',quote = F,row.names = T,sep='\t')
#186 365
#HCCD18
hccd18_cellage.exp<-HCCDB18_exp[intersect(sig_gene,rownames(HCCDB18_exp)),HCCDB18_cli$Samples]
dim(hccd18_cellage.exp)
#write.table(hccd18_cellage.exp,'results/ana/04.subtype/hccd18_cellage.exp.txt',quote = F,row.names = T,sep='\t')
#  177 389
#GSE14520_exp
gse14520_cellage.exp<-GSE14520_exp[intersect(sig_gene,rownames(GSE14520_exp)),GSE14520_cli$Samples]
dim(gse14520_cellage.exp)
#152 242
#GSE76427
gse76427_cellage.exp<-GSE76427_exp[intersect(sig_gene,rownames(GSE76427_exp)),GSE76427_cli$Samples]
dim(gse76427_cellage.exp)
#175 115

#一致性聚类
library(ConsensusClusterPlus)

clusterAlg_use=c('pam','hc','km','kmdist')[1]
distance_use=c('pearson','spearman','euclidean','canberra')[2]
#TCGA
df_exp=as.matrix(tcga_cellage.exp)
#df_exp=sweep(df_exp,1,apply(df_exp, 1, median))
df_exp=t(scale(t(df_exp)))
#df_exp=t(scale(t(df_exp),scale = F))
dim(df_exp)
clust_subtype_TCGA = ConsensusClusterPlus(df_exp
                                          , maxK = 10, reps = 500, pItem = 0.8
                                          , pFeature =1
                                          , title = "TCGA_subtype"
                                          , clusterAlg = clusterAlg_use
                                          , distance = distance_use
                                          , innerLinkage = 'ward.D2'
                                          , plot = "pdf"
                                          , seed = 123456
                                          , writeTable = T)

k=3
tcga.subtype=data.frame(Cluster=clust_subtype_TCGA[[k]]$consensusClass)
rownames(tcga.subtype)<-colnames(df_exp)
tcga.subtype$Cluster=paste0('MC',tcga.subtype$Cluster)
tcga.subtype[which(tcga.subtype$Cluster=='MC1'),1]='TMC2'
tcga.subtype[which(tcga.subtype$Cluster=='MC2'),1]='TMC3'
tcga.subtype[which(tcga.subtype$Cluster=='MC3'),1]='TMC1'

tcga.subtype$Cluster=gsub('TMC','clust',tcga.subtype$Cluster)
table(tcga.subtype$Cluster)
tcga.subtype$Samples=rownames(tcga.subtype)

ggplotKMCox(data.frame(time = tcga_cli[rownames(tcga.subtype),]$OS.time/365
                       , event = tcga_cli[rownames(tcga.subtype),]$OS
                       , tcga.subtype$Cluster)
            , add_text = ''
            #,labs = c('clust1','clust2')
)
write.table(data.frame(Samples=rownames(tcga.subtype),
                       time = tcga_cli[rownames(tcga.subtype),]$OS.time/365
                       , event = tcga_cli[rownames(tcga.subtype),]$OS
                       , tcga.subtype$Cluster),
            'results/ana/04.subtype/tcga.subtype.txt',quote = F,row.names = F,sep='\t')
write.table(data.frame(Samples=rownames(tcga.subtype),
                       time = tcga_cli[rownames(tcga.subtype),]$OS.time/365
                       , event = tcga_cli[rownames(tcga.subtype),]$OS
                       , tcga.subtype$Cluster),
            'results/files//tcga.subtype.txt',quote = F,row.names = F,sep='\t')

##HCCDB18
df_exp=as.matrix(hccd18_cellage.exp)
#df_exp=sweep(df_exp,1,apply(df_exp, 1, median))
#df_exp=t(scale(t(df_exp)))
#df_exp=t(scale(t(df_exp),scale = F))
dim(df_exp)
clust_subtype_hccdb18 = ConsensusClusterPlus(df_exp
                                             , maxK = 10, reps = 500, pItem = 0.8
                                             , pFeature =1
                                             , title = "HCCDB18_subtype"
                                             , clusterAlg = clusterAlg_use
                                             , distance = distance_use
                                             , innerLinkage = 'ward.D2'
                                             , plot = "pdf"
                                             , seed = 123456
                                             , writeTable = T)

k=3
hccdb18.subtype=data.frame(Cluster=clust_subtype_hccdb18[[k]]$consensusClass)
rownames(hccdb18.subtype)<-colnames(df_exp)
hccdb18.subtype$Cluster=paste0('MC',hccdb18.subtype$Cluster)
hccdb18.subtype[which(hccdb18.subtype$Cluster=='MC1'),1]='TMC1'
hccdb18.subtype[which(hccdb18.subtype$Cluster=='MC2'),1]='TMC2'
hccdb18.subtype[which(hccdb18.subtype$Cluster=='MC3'),1]='TMC3'

hccdb18.subtype$Cluster=gsub('TMC','clust',hccdb18.subtype$Cluster)
table(hccdb18.subtype$Cluster)
hccdb18.subtype$Samples=rownames(hccdb18.subtype)

ggplotKMCox(data.frame(time = HCCDB18_cli[rownames(hccdb18.subtype),]$OS.time/365
                       , event = HCCDB18_cli[rownames(hccdb18.subtype),]$OS
                       , hccdb18.subtype$Cluster)
            , add_text = ''
            #,labs = c('clust1','clust2')
)
write.table(data.frame(Samples=rownames(hccdb18.subtype),
                       time = HCCDB18_cli[rownames(hccdb18.subtype),]$OS.time/365
                       , event = HCCDB18_cli[rownames(hccdb18.subtype),]$OS
                       , hccdb18.subtype$Cluster),
            'results/ana/04.subtype/hccdb18.subtype.txt',quote = F,row.names = F,sep='\t')
write.table(data.frame(Samples=rownames(hccdb18.subtype),
                       time = HCCDB18_cli[rownames(hccdb18.subtype),]$OS.time/365
                       , event = HCCDB18_cli[rownames(hccdb18.subtype),]$OS
                       , hccdb18.subtype$Cluster),
            'results/files/hccdb18.subtype.txt',quote = F,row.names = F,sep='\t')

#gse14520
df_exp=as.matrix(gse14520_cellage.exp)
#df_exp=sweep(df_exp,1,apply(df_exp, 1, median))
df_exp=t(scale(t(df_exp)))
#df_exp=t(scale(t(df_exp),scale = F))
dim(df_exp)
clust_subtype_gse14520 = ConsensusClusterPlus(df_exp
                                              , maxK = 10, reps = 500, pItem = 0.8
                                              , pFeature =1
                                              , title = "GSE14520_subtype"
                                              , clusterAlg = clusterAlg_use
                                              , distance = distance_use
                                              , innerLinkage = 'ward.D2'
                                              , plot = "pdf"
                                              , seed = 123456
                                              , writeTable = T)

k=3
gse14520.subtype=data.frame(Cluster=clust_subtype_gse14520[[k]]$consensusClass)
rownames(gse14520.subtype)<-colnames(df_exp)
gse14520.subtype$Cluster=paste0('MC',gse14520.subtype$Cluster)
gse14520.subtype[which(gse14520.subtype$Cluster=='MC1'),1]='TMC2'
gse14520.subtype[which(gse14520.subtype$Cluster=='MC2'),1]='TMC3'
gse14520.subtype[which(gse14520.subtype$Cluster=='MC3'),1]='TMC1'

gse14520.subtype$Cluster=gsub('TMC','clust',gse14520.subtype$Cluster)
table(gse14520.subtype$Cluster)
gse14520.subtype$Samples=rownames(gse14520.subtype)

ggplotKMCox(data.frame(time = GSE14520_cli[rownames(gse14520.subtype),]$OS.time/365
                       , event = GSE14520_cli[rownames(gse14520.subtype),]$OS
                       , gse14520.subtype$Cluster)
            , add_text = ''
            #,labs = c('clust1','clust2')
)
write.table(data.frame(Samples=rownames(gse14520.subtype),
                       time = GSE14520_cli[rownames(gse14520.subtype),]$OS.time/365
                       , event = GSE14520_cli[rownames(gse14520.subtype),]$OS
                       , gse14520.subtype$Cluster),
            'results/ana/04.subtype/gse14520.subtype.txt',quote = F,row.names = F,sep='\t')
write.table(data.frame(Samples=rownames(gse14520.subtype),
                       time = GSE14520_cli[rownames(gse14520.subtype),]$OS.time/365
                       , event = GSE14520_cli[rownames(gse14520.subtype),]$OS
                       , gse14520.subtype$Cluster),
            'results/files/gse14520.subtype.txt',quote = F,row.names = F,sep='\t')

#gse76427
df_exp=as.matrix(gse76427_cellage.exp)
#df_exp=sweep(df_exp,1,apply(df_exp, 1, median))
#df_exp=t(scale(t(df_exp)))
df_exp=t(scale(t(df_exp),scale = F))
dim(df_exp)
clust_subtype_gse76427 = ConsensusClusterPlus(df_exp
                                              , maxK = 10, reps = 500, pItem = 0.8
                                              , pFeature =1
                                              , title = "GSE76427_subtype"
                                              , clusterAlg = clusterAlg_use
                                              , distance = distance_use
                                              , innerLinkage = 'ward.D2'
                                              , plot = "pdf"
                                              , seed = 123456
                                              , writeTable = T)

k=3
gse76427.subtype=data.frame(Cluster=clust_subtype_gse76427[[k]]$consensusClass)
rownames(gse76427.subtype)<-colnames(df_exp)
gse76427.subtype$Cluster=paste0('MC',gse76427.subtype$Cluster)
gse76427.subtype[which(gse76427.subtype$Cluster=='MC1'),1]='TMC1'
gse76427.subtype[which(gse76427.subtype$Cluster=='MC2'),1]='TMC2'
gse76427.subtype[which(gse76427.subtype$Cluster=='MC3'),1]='TMC3'

gse76427.subtype$Cluster=gsub('TMC','clust',gse76427.subtype$Cluster)
table(gse76427.subtype$Cluster)
gse76427.subtype$Samples=rownames(gse76427.subtype)

ggplotKMCox(data.frame(time = GSE76427_cli[rownames(gse76427.subtype),]$OS.time/365
                       , event = GSE76427_cli[rownames(gse76427.subtype),]$OS
                       , gse76427.subtype$Cluster)
            , add_text = ''
            #,labs = c('clust1','clust2')
)
#绘图
fig4d<-ggplotKMCox(data.frame(time = tcga_cli[rownames(tcga.subtype),]$OS.time/365
                              , event = tcga_cli[rownames(tcga.subtype),]$OS
                              , tcga.subtype$Cluster)
                   , add_text = ''
                   ,palette = ggsci::pal_jama()(10)
                   ,labs = c('clust1','clust2','clust3')
                   ,title = 'Senescence Subtype'
)
fig4d

fig4e<-ggplotKMCox(data.frame(time = HCCDB18_cli[rownames(hccdb18.subtype),]$OS.time/365
                              , event = HCCDB18_cli[rownames(hccdb18.subtype),]$OS
                              , hccdb18.subtype$Cluster)
                   , add_text = ''
                   ,labs = c('clust1','clust2','clust3')
                   ,palette = ggsci::pal_jama()(10)
                   ,title = 'Senescence Subtype'
)
fig4e

fig4de<-mg_merge_plot(fig4d,fig4e,ncol = 2,nrow = 1,labels = c('D','E'))
fig4de
#PCA分析
pca2d_plot<-function(dat,group,title,palette){
  pca <- prcomp(dat, scale. = TRUE)
  group=group
  pcaPredict=predict(pca)
  PCA = data.frame(PCA1 = pcaPredict[,1], PCA2 = pcaPredict[,2],group=group)
  PCA.mean=aggregate(PCA[,1:2],list(group=PCA$group),mean)
  #定义椭圆
  veganCovEllipse<-function (cov, center = c(0, 0), scale = 1, npoints = 100) {
    theta <- (0:npoints) * 2 * pi/npoints
    Circle <- cbind(cos(theta), sin(theta))
    t(center + scale * t(Circle %*% chol(cov)))
  }
  df_ell <- data.frame()
  for(g in as.character(unique(PCA$group))){
    df_ell <- rbind(df_ell, 
                    cbind(as.data.frame(with(PCA[PCA$group==g,],veganCovEllipse(cov.wt(cbind(PCA1,PCA2),wt=rep(1/length(PCA1),length(PCA1)))$cov,center=c(mean(PCA1),mean(PCA2))))),group=g))
  }
  p<-ggplot(data = PCA, aes(PCA1, PCA2)) + geom_point(aes(color = group)) +
    geom_path(data=df_ell, aes(x=PCA1, y=PCA2,colour=group), size=1, linetype=2)+
    annotate("text",x=PCA.mean$PCA1,y=PCA.mean$PCA2,label=PCA.mean$group)+
    theme_bw()+
    theme(panel.grid.major = element_blank(), 
          panel.grid.minor = element_blank(),
          plot.title = element_text(hjust = 0.5))+
    ggtitle(title)+
    scale_color_manual(name="",values =palette)
  return(p)
}
tcga_pca<-pca2d_plot(dat=t(tcga_cellage.exp[,tcga.subtype$Samples]),
                     group = tcga.subtype$Cluster,
                     title = 'TCGA Data Set',palette = ggsci::pal_jama()(10))
tcga_pca
hccdb18_pca<-pca2d_plot(dat=t(hccd18_cellage.exp[,hccdb18.subtype$Samples]),
                     group = hccdb18.subtype$Cluster,
                     title = 'HCCDB18 Data Set',palette = ggsci::pal_jama()(10))
hccdb18_pca
fig4fg<-mg_merge_plot(tcga_pca,hccdb18_pca,ncol = 2,nrow = 1,labels = c('F','G'))
fig4fg
fig4<-mg_merge_plot(fig4de,fig4fg,nrow = 2,ncol = 1,heights = c(1.2,1))

ggsave('results/ana/04.subtype/Fig4.pdf',fig4de,height = 5,width = 10)
#6、临床表型的差异分析####
dir.create('results/ana/05.subtype.cli')
tcga_subtype.cli=merge(tcga.subtype,tcga_cli,by='Samples')
rownames(tcga_subtype.cli)=tcga_subtype.cli$Samples
tcga_subtype.cli$Event=ifelse(tcga_subtype.cli$OS==0,'Alive','Dead')
fivenum(na.omit(tcga_subtype.cli$Age))
tcga_subtype.cli$Age1=ifelse(tcga_subtype.cli$Age>60,'>60',ifelse(tcga_subtype.cli$Age<=60,'<=60',NA))
write.table(tcga_subtype.cli,'results/ana/05.subtype.cli/tcga_subtype.cli.txt',quote = F,row.names = F,sep='\t')

pie_compare_plot<-function(dat,gname,group_cols){
  library(dplyr)
  g_n<-as.character(unique(dat[,gname]))
  vname <- setdiff(colnames(dat), gname)
  pie.gname=data.frame()
  fisher.p <- c()
  for (i in vname) {
    tmp <- table(dat[,gname], dat[,i])
    p <- round(chisq.test(tmp)$p.value,4)
    names(p) <- i
    fisher.p <- c(fisher.p, p)
    pie.dat <- 
      tmp %>% as.data.frame() %>% group_by(Var1) %>% mutate(Pct = Freq/sum(Freq)) %>% as.data.frame()
    pie.gname=rbind.data.frame(pie.gname,pie.dat)
  }
  #plot
  vname_col<-list()
  for(i in 1:length(vname)){
    col_i<-length(as.character(unique(na.omit(dat[,vname[i]]))))
    vname_col[[i]] <- alpha(group_cols[i], 
                            sample(x = 1:10,size = col_i,replace = F )/10)
  }
  
  #names(vname_col)=vname
  col_num<-ncol(dat)
  row_num<-length(g_n)
  row_nums=1+2*row_num+2
  #c(1:col_num,2*row_num*col_num+1)
  #第一行
  nums1=c()
  for (i in 1:col_num){
    nums1=c(nums1,rep(i,3))
  }
  #两行
  nums2=c()
  for (j in 1:row_num){
    nums21=c()
    for (i in (col_num*j+1):((1+j)*col_num)){
      nums21=c(nums21,rep(i,3))
    }
    nums2=c(nums2,nums21,nums21)
  }
  
  #倒数第二行
  nums3=c()
  #(1+row_num)*col_num+1,(2+row_num)*col_num
  for (i in (((1+row_num)*col_num+1):((2+row_num)*col_num))){
    nums3=c(nums3,rep(i,3))
  }
  #最后一行
  nums4=c(rep(((2+row_num)*col_num)+1,col_num*3))
  nums=c(nums1,nums2,nums3,nums4)
  showLayout <- F 
  
  layout(matrix(nums,byrow = T,nrow = row_nums))
  if(showLayout) {
    layout.show(n = ((2+row_num)*col_num)+1) # 直观展示画布分布
  }
  par(bty="n", mgp = c(0,0,0), mar = c(0,0,0,0), lwd = 2) 
  plot(1,1,
       xlab = "",xaxt = "n", # 不显示x坐标轴
       ylab = "",yaxt = "n") # 不显示y坐标轴
  rect(par("usr")[1],par("usr")[3],par("usr")[2],par("usr")[4],col = "white") # 背景涂黑
  text((par("usr")[1]+par("usr")[2])/2, # 用par("usr")来获取该画布的绝对位置
       (par("usr")[3]+par("usr")[4])/2,
       gname,cex = 2, col = "black") # 显示图标题
  #标题
  for (i in 1:length(vname)){
    plot(1,1,
         xlab = "",xaxt = "n", 
         ylab = "",yaxt = "n") 
    rect(par("usr")[1],par("usr")[3],par("usr")[2],par("usr")[4],col = "white") 
    text((par("usr")[1]+par("usr")[2])/2, 
         (par("usr")[3]+par("usr")[4])/2,
         vname[i],cex = 2, col = "black") 
  }
  #抬头和扇形图
  for (i in 1:length(g_n)){
    plot(1,1,
         xlab = "",xaxt = "n", # 不显示x坐标轴
         ylab = "",yaxt = "n") # 不显示y坐标轴
    rect(par("usr")[1],par("usr")[3],par("usr")[2],par("usr")[4],col = "white") # 背景涂黑
    text((par("usr")[1]+par("usr")[2])/2,
         (par("usr")[3]+par("usr")[4])/2,
         paste0(g_n[i],"\n(n = ",as.numeric(table(dat[,gname])[i]),")"),cex = 2, col = "black") 
    for (j in 1:length(vname)){
      aa=as.character(unique(dat[,vname[j]]))
      pie.gname1=pie.gname[pie.gname$Var1==g_n[i],]
      pie.gname1=pie.gname[pie.gname$Var1==g_n[i] & pie.gname$Var2 %in% aa,]
      pie(pie.gname1$Pct, 
          col = vname_col[[j]], 
          border = "white",  
          radius = 1, 
          labels = NA,
          init.angle = 90)
      symbols(0,0, circles = .55, inches = FALSE, col = "white", bg = "white", lty = 0, add = TRUE)
    }
    
  }
  
  plot(1,1,
       xlab = "",xaxt = "n",
       ylab = "",yaxt = "n")
  rect(par("usr")[1],par("usr")[3],par("usr")[2],par("usr")[4],col = "white") 
  text((par("usr")[1]+par("usr")[2])/2,
       (par("usr")[3]+par("usr")[4])/2,
       'chisq.test',cex = 2, col = "black") 
  for(i in vname){
    plot(1,1,col = "white",
         xlab = "",xaxt = "n", # 不显示x坐标轴
         ylab = "",yaxt = "n") # 不显示y坐标轴
    text((par("usr")[1]+par("usr")[2])/2, # 用par("usr")来获取该画布的绝对位置
         (par("usr")[3]+par("usr")[4])/2,
         paste0("p = ",fisher.p[i]),cex = 1.5, col = "black") # 显示图标题
    abline(h = par("usr")[3], col = "black")
  }
  plot(0,0,col = "white",
       xlab = "",xaxt = "n", # 不显示x坐标轴
       ylab = "",yaxt = "n") # 不显示y坐标轴
  leg_nam=c()
  for (ii in 1:length(vname)){
    aa=as.character(unique(dat[,vname[ii]]))
    pie.gname1=pie.gname[pie.gname$Var2 %in% aa,]
    leg_nam=c(leg_nam,as.character(unique(pie.gname1$Var2)))
  }
  vname_col_name=unlist(vname_col)
  
  legend("topleft",ncol=ceiling(length(leg_nam)/2)+1,
         legend = leg_nam,
         fill = vname_col_name,
         border = NA,
         bty = "n", 
         cex = 1.2,
         x.intersp = 0.05,
         y.intersp = 1,
         text.width = 0.1, 
         horiz = F)
}


pdf('results/ana/05.subtype.cli/Fig6.pdf',height = 7,width = 15)
pie_compare_plot(dat = tcga_subtype.cli[,c("Cluster","Gender","T.Stage","N.Stage","Stage","Age1",'Grade','Event')],
                 gname = 'Cluster',
                 group_cols = c(ggsci::pal_lancet()(9)))
dev.off()
#7、突变的差异####
dir.create('results/ana/06.subtype.cnv/clust1',recursive = T)
dir.create('results/ana/06.subtype.cnv/clust2',recursive = T)
dir.create('results/ana/06.subtype.cnv/clust3',recursive = T)

metadata <- read.delim('/pub1/data/mg_projects/TCGA/Matrix/cnvs/all.sample.txt',sep='\t',header = F,check.names = F)
cnv_dir='/pub1/data/mg_projects/TCGA/Matrix/cnvs/'
tur_name='TCGA-LIHC'
metadata=metadata[grep(pattern = tur_name,metadata$V2),c(2,3,4)]
head(metadata)

metadata=data.frame(GDC_Aliquot=stringr::str_split_fixed(metadata$V2,'/',6)[,6],
                    Samples=paste0(metadata$V3,'-',ifelse(metadata$V4==1,'01',metadata$V4)))
head(metadata)
metadata=metadata[grep('nocnv_grch38.seg.v2.txt$',metadata$GDC_Aliquot),]
cnv_df=data.frame()
for (i in 1:nrow(metadata)){
  cnv_df1=data.table::fread(file=paste0(cnv_dir,'/',tur_name,'/',metadata$GDC_Aliquot[i]),
                            data.table = F)
  cnv_df1$Samples=metadata$Samples[i]
  cnv_df=rbind(cnv_df,cnv_df1)
  
}

head(cnv_df)
cnv_df <- cnv_df[,c("Samples", "Chromosome","Start", "End", "Num_Probes", "Segment_Mean")]
head(cnv_df)

table(tcga.subtype$Cluster)
colnames(cnv_df)[1]='Sample'
c1_sam<-tcga.subtype[tcga.subtype$Cluster=='clust1',"Samples"]
c2_sam<-tcga.subtype[tcga.subtype$Cluster=='clust2',"Samples"]
c3_sam<-tcga.subtype[tcga.subtype$Cluster=='clust3',"Samples"]

cnv_df=unique(cnv_df)
cnv_df1=cnv_df[cnv_df$Sample %in% c1_sam,]
cnv_df2=cnv_df[cnv_df$Sample %in% c2_sam,]
cnv_df3=cnv_df[cnv_df$Sample %in% c3_sam,]

cnv_df1=na.omit(cnv_df1)
cnv_df2=na.omit(cnv_df2)
cnv_df3=na.omit(cnv_df3)

#过滤
write.table(cnv_df1, file = "results/ana/06.subtype.cnv/C1_segment_file.txt", sep = "\t", row.names = F, quote = F)
write.table(cnv_df2, file = "results/ana/06.subtype.cnv/C2_segment_file.txt", sep = "\t", row.names = F, quote = F)
write.table(cnv_df3, file = "results/ana/06.subtype.cnv/C3_segment_file.txt", sep = "\t", row.names = F, quote = F)

# cd /pub1/data/mg_projects/users/wangtl/202201/20220811_LIHC.cellAge.scRNA/results/ana/06.subtype.cnv
# Rscript /pub1/data/mg_projects/users/wangtl/public/preprocess.R C1_segment_file.txt 0 C1_segment_file1.txt
# Rscript /pub1/data/mg_projects/users/wangtl/public/preprocess.R C2_segment_file.txt 0 C2_segment_file1.txt
# Rscript /pub1/data/mg_projects/users/wangtl/public/preprocess.R C3_segment_file.txt 0 C3_segment_file1.txt

# /home/wangtl/soft/gistic2 -b ./clust1 -seg ./C1_segment_file1.txt -mk /pub1/data/mg_projects/users/wangtl/public/marker_file.txt -refgene /home/wangtl/soft/refgenefiles/hg38.UCSC.add_miR.160920.refgene.mat -conf 0.9
# /home/wangtl/soft/gistic2 -b ./clust2 -seg ./C2_segment_file1.txt -mk /pub1/data/mg_projects/users/wangtl/public/marker_file.txt -refgene /home/wangtl/soft/refgenefiles/hg38.UCSC.add_miR.160920.refgene.mat -conf 0.9
# /home/wangtl/soft/gistic2 -b ./clust3 -seg ./C3_segment_file1.txt -mk /pub1/data/mg_projects/users/wangtl/public/marker_file.txt -refgene /home/wangtl/soft/refgenefiles/hg38.UCSC.add_miR.160920.refgene.mat -conf 0.9

#绘图
library(TCGAbiolinks)
library(SummarizedExperiment)
chrom_extract <- function(BSgenome.hg  = NULL) {
  if (is.null(BSgenome.hg )) stop("NULL object !", call. = FALSE)
  obj <- list(species = GenomeInfoDb::organism(BSgenome.hg), genomebuild = BSgenome::providerVersion(BSgenome.hg))
  df <- data.frame(chrom = BSgenome::seqnames(BSgenome.hg), chrN = seq_along(BSgenome::seqnames(BSgenome.hg)), chr.length = GenomeInfoDb::seqlengths(BSgenome.hg), stringsAsFactors = FALSE)
  df <- df[1:24,]
  df$chr.length.sum <- cumsum(as.numeric(df$chr.length))
  df$chr.length.cumsum <- c(0, df$chr.length.sum[-nrow(df)])
  df$middle.chr <- round(diff(c(0, df$chr.length.sum)) /2)
  df$middle.chr.genome <- df$middle.chr + df$chr.length.cumsum
  obj$chromosomes <- df
  obj$chrom2chr <- sapply(obj$chromosomes$chrom, function(k) { obj$chromosomes$chrN[obj$chromosomes$chrom == k]}, simplify = FALSE)
  obj$chr2chrom <- sapply(obj$chromosomes$chrN, function(k) { obj$chromosomes$chrom[obj$chromosomes$chrN == k]}, simplify = FALSE)
  names(obj$chr2chrom) <- obj$chromosomes$chrN
  obj$genome.length <- sum(as.numeric(obj$chromosomes$chr.length), na.rm = TRUE)
  return(obj)
}

# Extract a chromosomes reference loci
BSgenome.hg = "BSgenome.Hsapiens.UCSC.hg38"
BSg.obj <- getExportedValue(BSgenome.hg, BSgenome.hg)
genome.version <- BSgenome::providerVersion(BSg.obj)
chrom <- chrom_extract(BSg.obj)
#clsut1
C1_scores <- read.table("results/ana/06.subtype.cnv/clust1/scores.gistic", sep="\t",header=T,stringsAsFactors = F)
C1_scores=C1_scores[C1_scores$Type %in% c('Amp','Del'),]
#clust2
C2_scores <- read.table("results/ana/06.subtype.cnv/clust2/scores.gistic", sep="\t",header=T,stringsAsFactors = F)
C2_scores=C2_scores[C2_scores$Type %in% c('Amp','Del'),]
#clust3
C3_scores <- read.table("results/ana/06.subtype.cnv/clust3/scores.gistic", sep="\t",header=T,stringsAsFactors = F)
C3_scores=C3_scores[C3_scores$Type %in% c('Amp','Del'),]

cnv_freq_plot<-function(dat,yname,ylab,col,chrom,ylim){
  dat[dat$Chromosome==23,"Chromosome"]="X"
  dat[dat$Chromosome==24,"Chromosome"]="Y"
  chrID <- unname(unlist(chrom$chrom2chr[as.character(paste0("chr",dat$Chromosome))]))
  dat$Start.geno <- dat$Start + chrom$chromosomes$chr.length.cumsum[chrID]
  dat$End.geno <- dat$End + chrom$chromosomes$chr.length.cumsum[chrID]
  dat.amp <- dat[dat$Type=="Amp",]
  dat.del <- dat[dat$Type=="Del",]
  ink <- chrom$chromosomes$chrN %in% chrID
  
  if(yname=='G.score'){
    m.pos <- c(ylim[1]+1,ylim[2]-1)
    m.mod <- -(chrom$chromosomes$chrN[ink] %% 2) +2
  }else{
    m.pos <- c(ylim[1]+10,ylim[2]-10)
    m.mod <- -(chrom$chromosomes$chrN[ink] %% 2) +2
  }
  plot(dat.amp$Start.geno, dat.amp[,yname],
       pch = ".", type='h',cex = 2, xaxs = "i", yaxs = "i",
       xlim = c(0,chrom$genome.length), 
       ylim = ylim,
       main = "", cex.main = 2, 
       ylab = ylab, xlab = NA,
       cex.lab = 1, col = adjustcolor(col[1], alpha.f = .8),
       xaxt = "n", lwd = 2, las=1) 
  lines(dat.del$Start.geno, dat.del[,yname], type='h', lwd = 2, col = adjustcolor(col[2], alpha.f = .8))
  yrange = abs(diff(ylim))+2
  try(text(x = chrom$chromosomes$middle.chr.geno[ink], 
           y = m.pos[m.mod], 
           labels = stringr::str_sub(chrom$chromosomes$chrom[ink],
                                     start = 4), cex = 1))
  abline(h = 0.0, col = 1, lwd = 1, lty = 3)
  abline(v = c(0,chrom$chromosomes$chr.length.sum), col = 1, lty = 3, lwd = 1)
  
  col1 <- adjustcolor(col[1], alpha.f = .8)
  col2 <- adjustcolor(col[2], alpha.f = .8)
  legend("topleft", c("gain","loss"), cex=0.6, bty="n", fill=c(col1,col2))
}

#freq
C1_scores$frequency=ifelse(C1_scores$Type=='Amp',C1_scores$frequency *100,C1_scores$frequency * (-100))
C2_scores$frequency=ifelse(C2_scores$Type=='Amp',C2_scores$frequency *100,C2_scores$frequency * (-100))
C3_scores$frequency=ifelse(C3_scores$Type=='Amp',C3_scores$frequency *100,C3_scores$frequency * (-100))

pdf("results/ana/06.subtype.cnv/C1_copy_number_frequency.pdf",width = 10,height = 5)
cnv_freq_plot(dat = C1_scores,yname = 'frequency',
              ylab='Percentage/Frequency',
              ylim = c(-100,100),chrom = chrom,
              col=ggsci::pal_npg("nrc")(10)[2:3])
dev.off()
pdf("results/ana/06.subtype.cnv/C2_copy_number_frequency.pdf",width = 10,height = 5)
cnv_freq_plot(dat = C2_scores,yname = 'frequency',
              ylab='Percentage/Frequency',
              ylim = c(-100,100),chrom = chrom,
              col=ggsci::pal_npg("nrc")(10)[2:3])
dev.off()
pdf("results/ana/06.subtype.cnv/C3_copy_number_frequency.pdf",width = 10,height = 5)
cnv_freq_plot(dat = C3_scores,yname = 'frequency',
              ylab='Percentage/Frequency',
              ylim = c(-100,100),chrom = chrom,
              col=ggsci::pal_npg("nrc")(10)[2:3])
dev.off()
#snv
tcga_maf=getTCGAMAFByCode('LIHC')
mg_group_oncoplot_byMAF_1=function(maf=NULL,mafPath=NULL,group=NULL,genes=NULL,top=NULL,annotationColor='npg',isTCGA =T){#group为两列，第一列为样本名称，第二列为分类
  library('maftools')
  if(is.null(maf)){
    if(is.null(mafPath)){
      maf=NULL
    }else{
      maf = read.maf(maf = mafPath,isTCGA =isTCGA ) 
    }
  }
  if(!is.null(group)&!is.null(maf)){
    cl.dt=as.data.frame(maf@clinical.data)
    ul=unique(nchar(as.character(group[,1])))
    if(length(ul)>1){
      gp=group[match(as.character(cl.dt[,1]),group[,1]),2] 
    }else{
      gp=group[match(substr(as.character(cl.dt[,1]),1,ul),group[,1]),2] 
    }
    cl.dt$Cluster=as.character(gp)
    colnames(cl.dt)=c(colnames(cl.dt)[1],colnames(group)[2])
    cl.dt=cl.dt[which(!is.na(cl.dt[,2])),]
    cl.dt[,2]=as.character(cl.dt[,2])
    data.table::setDT(cl.dt)
    maf@clinical.data=cl.dt
    if(is.null(top)){
      if(!is.null(genes)){
        top=length(genes)
      }else{
        top=15
      }
    }
    gp=names(table(group[,2]))
    cl=mg_get_ggsci_colN(annotationColor,length(gp))
    names(cl)=gp
    acl=list(A=cl)
    names(acl)=colnames(group)[2]
    oncoplot(maf = maf,top = top,genes = genes
             ,clinicalFeatures = colnames(group)[2]
             ,sortByAnnotation = TRUE
             ,annotationColor = acl)
  }
  return(maf)  
}

group1=tcga.subtype[, c(2,1)]
group1$Samples=substr(group1$Samples,1,12)
pdf('results/ana/06.subtype.cnv/Fig7B.pdf',width = 10,height = 5)
mg_group_oncoplot_byMAF_1(maf=tcga_maf
                          ,group=group1
                          ,top = 15
                          ,annotationColor='nejm')
dev.off()
#8、生物学特征####
dir.create('results/ana/07.bio.feat')
tcga_tmp_log2_T=tcga_tmp_log2[,tcga_cli$Samples]
dim(tcga_tmp_log2_T)
#CCP
library(ggpubr)
immu_ccp<-function(exp_data){
  #cell cycle progression(CCP,31个基因 ,PMID: 21310658)
  ccp.gene=c('FOXM1','ASPM','TK1','PRC1','CDC20','BUB1B','PBK','DTL','CDKN3','RRM2','ASF1B','CEP55','CDC2','DLGAP5','C18orf24','RAD51','KIF11','BIRC5','RAD54L','CENPM','KIAA0101','KIF20A','PTTG1','CDCA8','NUSAP1','PLK1','CDCA3','ORC6L','CENPF','TOP2A','MCM10')
  gs.score=ssGSEAScore_by_genes(exp_data,ccp.gene)
  rownames(gs.score)='CCP'
  gs.score=t(gs.score)
  return(gs.score)
}
tcga.ccp=immu_ccp(tcga_tmp_log2_T)
tcga.ccp=crbind2DataFrame(tcga.ccp)
tcga.ccp.subtype=merge(data.frame(Samples=rownames(tcga.ccp),CCP=tcga.ccp$CCP),
                       tcga.subtype,by='Samples')
tcga.ccp.subtype=tcga.ccp.subtype[order(tcga.ccp.subtype$Cluster),]
sig_boxplot<-function(dat,leg,ylab,palette=ggsci::pal_lancet()(10)[3:4]){
  library(ggpubr)
  dat=na.omit(dat)
  colnames(dat)=c('group','gene')
  dat=dat[order(dat$group),]
  all.combn=combn(as.character(unique(dat$group)),2)
  my_comparisons=lapply(seq_len(ncol(all.combn)), function(i) all.combn[,i])
  pp=ggboxplot(dat, 
               x='group', y='gene', color = 'group',
               palette =  palette,
               short.panel.labs = T,outlier.shape = NA)+
    stat_compare_means(comparisons=my_comparisons,method="wilcox.test",label = "p.signif")+
    ylab(ylab)+xlab('')+labs(color=leg)
  return(pp)
}
sig_violin<-function(dat,leg,ylab,palette=ggsci::pal_lancet()(10)[3:4]){
  library(ggpubr)
  dat=na.omit(dat)
  colnames(dat)=c('group','gene')
  dat=dat[order(dat$group),]
  all.combn=combn(as.character(unique(dat$group)),2)
  my_comparisons=lapply(seq_len(ncol(all.combn)), function(i) all.combn[,i])
  p<-ggplot(dat, aes(x=group, y=gene,fill=group)) + 
    geom_violin(trim=FALSE,color="black")+
    stat_compare_means(comparisons=my_comparisons,method="wilcox.test",label = "p.signif")+
    ylab(ylab)+xlab('')+labs(fill=leg)+scale_fill_manual(values = palette)+theme_classic()
  return(p)
  
}


fig8a<-sig_violin(dat = tcga.ccp.subtype[,c("Cluster","CCP")],
                   leg = 'Senescence Subtype',ylab = 'CCP Score',
                   palette = ggsci::pal_jama()(10))

fig8a
write.table(tcga.ccp.subtype,'results/ana/07.bio.feat/tcga.ccp.subtype.txt',quote = F,sep='\t',row.names = F)
#Cell cycle G1/S(https://www.kegg.jp/pathway/hsa04110)
immu_g1.s.cell.cycle<-function(exp_data){
  #G1/S cell cycle(27个)
  gene=c('MYC','MAX','ZBTB17','CDKN2B','CCND1','CCND2','CCND3','CDK4','CDK6','RB1','E2F1','E2F2','E2F3','CDKN2A','MDM2','TP53','CDKN1A','SKP1','CUL1','RBX1','SKP2','CDKN1B','CCNA2','CCNA1','CCNE1','CCNE2','CDK2')
  gs.score=ssGSEAScore_by_genes(exp_data,gene)
  rownames(gs.score)='G1/S Cell Cycle'
  gs.score=t(gs.score)
  return(gs.score)
}
tcga.g1.s.cell.cycle=immu_g1.s.cell.cycle(tcga_tmp_log2_T)
tcga.g1.s.cell.cycle=crbind2DataFrame(tcga.g1.s.cell.cycle)
tcga.g1.s.cell.cycle.subtype=merge(data.frame(Samples=rownames(tcga.g1.s.cell.cycle),
                                              pathway=tcga.g1.s.cell.cycle$`G1/S Cell Cycle`),
                                   tcga.subtype,by='Samples')
tcga.g1.s.cell.cycle.subtype=tcga.g1.s.cell.cycle.subtype[order(tcga.g1.s.cell.cycle.subtype$Cluster),]

fig8b<-sig_violin(dat = tcga.g1.s.cell.cycle.subtype[,c("Cluster","pathway")],
                   leg = 'Senescence Subtype',ylab = 'G1/S Cell Cycle Score',
                   palette = ggsci::pal_jama()(10))
fig8b
write.table(tcga.g1.s.cell.cycle.subtype,'results/ana/07.bio.feat/tcga.g1.s.cell.cycle.subtype.txt',quote = F,sep='\t',row.names = F)
#

#G2M_CHECKPOINT
immu_g2m.checkpoint<-function(exp_data){
  #HALLMARK_G2M_CHECKPOINT h.all.v7.0.symbols.gmt
  gene=c('AURKA','CCNA2','TOP2A','CCNB2','CENPA','BIRC5','CDC20','PLK1','TTK','PRC1','NDC80','KIF11','NUSAP1','CKS2','KIF2C','MKI67','AURKB','TPX2','SMC4','BUB1','CENPF','RACGAP1','CENPE','AC027237.1','UBE2C','MCM6','MCM3','PTTG1','CDK1','KIF4A','ESPL1','MAD2L1','NEK2','KIF22','HMMR','KPNA2','CDKN3','CDC25A','H2AFX','CDC25B','PLK4','CDC6','CCNF','MCM5','LMNB1','E2F3','KIF15','CHEK1','UBE2S','NSD2','HMGB3','DBF4','TACC3','MCM2','CDKN2C','CDKN1B','FANCC','NASP','STAG1','GINS2','FBXO5','POLQ','EZH2','RAD21','STMN1','SUV39H1','PRIM2','E2F1','CHAF1A','NOLC1','GSPT1','BUB3','SMC1A','ILF3','CDC7','INCENP','CKS1B','EXO1','H2AFZ','TFDP1','CCND1','KPNB1','JPT1','LBR','HUS1','KIF20B','TOP1','PDS5B','SRSF1','STIL','ABL1','DTYMK','CDC27','BARD1','ATF5','CDC45','ODC1','XPO1','SFPQ','TMPO','PML','BRCA2','CTCF','KNL1','KMT5A','SLC38A1','TRA2B','MYBL2','TROAP','TENT4A','CUL3','MAPK14','HIST1H2BK','MYC','AMD1','CBX1','CHMP1A','DKC1','YTHDC1','CCNT1','TGFB1','ATRX','LIG3','NUP50','SLC7A5','RBL1','NUMA1','RAD54L','EFNA5','PRPF4B','UCK2','ARID4A','CUL1','UPF1','DR1','MNAT1','SMC2','RBM14','RPA2','SQLE','ORC6','CDK4','POLE','RASAL2','HOXC10','RPS6KA5','CUL4A','SLC7A1','FOXN3','HMGA1','AC091021.1','TRAIP','PRMT5','CUL5','DDX39A','MARCKS','PBK','ORC5','SAP30','KATNA1','HNRNPD','POLA2','HIRA','HIF1A','SYNCRIP','TLE3','NCL','RAD23B','E2F2','EGF','HMGN2','SRSF10','SNRPD1','CASP8AP2','SMARCC1','SLC12A2','NOTCH2','TNPO2','SMAD3','MAP3K20','HSPA8','G3BP1','PTTG3P','DMD','MEIS1','HNRNPU','SRSF2','MT2A','NUP98','EWSR1','KIF5B','MTF2','E2F4','BCL3','PURA','MEIS2','PAFAH1B1','WRN','H2AFV','ODF2')
  gs.score=ssGSEAScore_by_genes(exp_data,gene)
  rownames(gs.score)='G2M Checkpoint'
  gs.score=t(gs.score)
  return(gs.score)
}
tcga.g2m.checkpoint=immu_g2m.checkpoint(tcga_tmp_log2_T)
tcga.g2m.checkpoint=crbind2DataFrame(tcga.g2m.checkpoint)
tcga.g2m.checkpoint.subtype=merge(data.frame(Samples=rownames(tcga.g2m.checkpoint),pathway=tcga.g2m.checkpoint$`G2M Checkpoint`),
                                  tcga.subtype,by='Samples')
tcga.g2m.checkpoint.subtype=tcga.g2m.checkpoint.subtype[order(tcga.g2m.checkpoint.subtype$Cluster),]

fig8c<-sig_violin(dat = tcga.g2m.checkpoint.subtype[,c("Cluster","pathway")],
                   leg = 'Senescence Subtype',ylab = 'G2M Checkpoint Score',
                   palette = ggsci::pal_jama()(10))
fig8c
write.table(tcga.g2m.checkpoint.subtype,'results/ana/07.bio.feat/tcga.g2m.checkpoint.subtype.txt',quote = F,sep='\t',row.names = F)
#端粒酶延长
#REACTOME_TELOMERE_EXTENSION_BY_TELOMERAS_MERASE
immu_telomere<-function(exp_data){
  #HALLMARK_G2M_CHECKPOINT h.all.v7.0.symbols.gmt
  gene=c('ACD','ANKRD28','CCNA1','CCNA2','CDK2','DKC1','GAR1','NHP2','NOP10','PIF1','POT1','PPP6C','PPP6R3','RTEL1','RUVBL1','RUVBL2','SHQ1','TERF1','TERF2','TERF2IP','TERT','TINF2','WRAP53')
  gs.score=ssGSEAScore_by_genes(exp_data,gene)
  rownames(gs.score)='Telomere Extension By Telomerase '
  gs.score=t(gs.score)
  return(gs.score)
}
tcga.telomere=immu_telomere(tcga_tmp_log2_T)
tcga.telomere=crbind2DataFrame(tcga.telomere)
tcga.telomere.subtype=merge(data.frame(Samples=rownames(tcga.telomere),pathway=tcga.telomere$`Telomere Extension By Telomerase `),
                            tcga.subtype,by='Samples')
tcga.telomere.subtype=tcga.telomere.subtype[order(tcga.telomere.subtype$Cluster),]

fig8d<-sig_violin(dat = tcga.telomere.subtype[,c("Cluster","pathway")],
                   leg = 'Senescence Subtype',ylab = 'Telomere Extension By Telomerase Score',
                   palette = ggsci::pal_jama()(10))
fig8d
write.table(tcga.telomere.subtype,'results/ana/07.bio.feat/tcga.telomere.subtype.txt',quote = F,sep='\t',row.names = F)

#EMT
immu_EMT<-function(exp_data){
  #HALLMARK_EPITHELIAL_MESENCHYMAL_TRANSITION :h.all.v7.0.symbols.gmt
  EMT.gene=c('COL3A1','COL5A2','COL5A1','FBN1','COL1A1','FN1','COL6A3','SERPINE1','COL1A2','COL4A1','COL4A2','VCAN','IGFBP3','TGFBI','SPARC','LUM','LAMC1','LOX','LAMC2','CCN2','TAGLN','COL7A1','LOXL2','COL6A2','ITGAV','THBS2','COL16A1','NNMT','TPM1','CDH2','MMP2','COL11A1','THBS1','FAP','BGN','SERPINH1','FSTL1','POSTN','THY1','SPP1','TNC','TFPI2','NID2','ITGB5','MMP3','VIM','LOXL1','FBLN5','COL12A1','ELN','CDH11','COMP','SPOCK1','BMP1','IL32','LAMA3','TIMP1','QSOX1','TIMP3','VCAM1','CCN1','EDIL3','CALD1','MAGEE1','FBLN1','SGCB','ECM1','LAMA2','FSTL3','TPM2','INHBA','DAB2','EMP3','BASP1','ITGA5','MGP','VEGFA','CXCL1','WNT5A','SDC1','PLOD2','PCOLCE','GREM1','ITGB1','COL5A3','RHOB','HTRA1','FGF2','SNTB1','GADD45A','MEST','LRRC15','TNFRSF11B','CD59','ACTA2','EFEMP2','MATN2','PCOLCE2','SERPINE2','GPC1','ABI3BP','FUCA1','SLIT3','LAMA1','PMEPA1','COL8A2','FBN2','IGFBP2','PFN2','SDC4','CD44','GADD45B','CXCL8','GLIPR1','ANPEP','P3H1','VEGFC','MMP14','SGCD','PLOD1','MATN3','MYL9','SLC6A8','CALU','PRRX1','TNFRSF12A','FMOD','ID2','GEM','PLAUR','MYLK','TGFB1','SFRP1','PLOD3','IL6','APLP1','FBLN2','MSX1','PTX3','FZD8','JUN','FERMT2','DKK1','SNAI2','DST','TPM4','DCN','GJA1','PMP22','IGFBP4','COPA','LRP1','ITGA2','FLNA','MFAP5','PTHLH','TGFBR3','SFRP4','LGALS1','RGS4','CDH6','SAT1','NT5E','DPYSL3','PPIB','TGM2','SGCG','ITGB3','PDLIM4','CTHRC1','ECM2','CRLF1','AREG','IL15','MCM7','GAS1','PRSS2','CADM1','OXTR','SCG2','CXCL6','MMP1','TNFAIP3','CAPG','CAP2','MXRA5','FOXC2','NTM','ENO2','FAS','BDNF','ADAM12','PVR','CXCL12','PDGFRB','SLIT2','NOTCH2','COLGALT1','GPX7','WIPF1')
  gs.score=ssGSEAScore_by_genes(exp_data,EMT.gene)
  rownames(gs.score)='EMT'
  gs.score=t(gs.score)
  return(gs.score)
}
tcga.EMT=immu_EMT(tcga_tmp_log2_T)
tcga.EMT=crbind2DataFrame(tcga.EMT)
tcga.EMT.subtype=merge(data.frame(Samples=rownames(tcga.EMT),EMT=tcga.EMT$EMT),
                       tcga.subtype,by='Samples')
write.table(tcga.EMT.subtype,'results/ana/07.bio.feat/tcga.EMT.subtype.txt',quote = F,row.names = F,sep='\t')
tcga.EMT.subtype=tcga.EMT.subtype[order(tcga.EMT.subtype$Cluster),]

fig8e<-sig_violin(dat = tcga.EMT.subtype[,c("Cluster","EMT")],
                   leg = 'Senescence Subtype',ylab = 'EMT Score',
                   palette = ggsci::pal_jama()(10))
fig8e
#缺氧
immu_hypoxia<-function(exp_data){
  #缺氧型基因 HALLMARK_HYPOXIA
  hypoxia.gene=c('PGK1','PDK1','GBE1','PFKL','ALDOA','ENO2','PGM1','NDRG1','HK2','ALDOC','GPI','MXI1','SLC2A1','P4HA1','ADM','P4HA2','ENO1','PFKP','AK4','FAM162A','PFKFB3','VEGFA','BNIP3L','TPI1','ERO1A','KDM3A','CCNG2','LDHA','GYS1','GAPDH','BHLHE40','ANGPTL4','JUN','SERPINE1','LOX','GCK','PPFIA4','MAFF','DDIT4','SLC2A3','IGFBP3','NFIL3','FOS','RBPJ','HK1','CITED2','ISG20','GALK1','WSB1','PYGM','STC1','ZNF292','BTG1','PLIN2','CSRP2','VLDLR','JMJD6','EXT1','F3','PDK3','ANKZF1','UGP2','ALDOB','STC2','ERRFI1','ENO3','PNRC1','HMOX1','PGF','GAPDHS','CHST2','TMEM45A','BCAN','ATF3','CAV1','AMPD3','GPC3','NDST1','IRS2','SAP30','GAA','SDC4','STBD1','IER3','PKLR','IGFBP1','PLAUR','CAVIN3','CCN5','LARGE1','NOCT','S100A4','RRAGD','ZFP36','EGFR','EDN2','IDS','CDKN1A','RORA','DUSP1','MIF','PPP1R3C','DPYSL4','KDELR3','DTNA','ADORA2B','HS3ST1','CAVIN1','NR3C1','KLF6','GPC4','CCN1','TNFAIP3','CA12','HEXA','BGN','PPP1R15A','PGM2','PIM1','PRDX5','NAGK','CDKN1B','BRS3','TKTL1','MT1E','ATP7A','MT2A','SDC3','TIPARP','PKP1','ANXA2','PGAM2','DDIT3','PRKCA','SLC37A4','CXCR4','EFNA3','CP','KLF7','CCN2','CHST3','TPD52','LXN','B4GALNT2','PPARGC1A','BCL2','GCNT2','HAS1','KLHL24','SCARB1','SLC25A1','SDC2','CASP6','VHL','FOXO3','PDGFB','B3GALT6','SLC2A5','SRPX','EFNA1','GLRX','ACKR3','PAM','TGFBI','DCN','SIAH2','PLAC8','FBP1','TPST2','PHKG1','MYH9','CDKN1C','GRHPR','PCK1','INHA','HSPA5','NDST2','NEDD4L','TPBG','XPNPEP1','IL6','SLC6A6','MAP3K1','LDHC','AKAP12','TES','KIF5A','LALBA','COL5A1','GPC1','HDLBP','ILVBL','NCAN','TGM2','ETS1','HOXB9','SELENBP1','FOSL2','SULT2B1','TGFB3')
  gs.score=ssGSEAScore_by_genes(exp_data,hypoxia.gene)
  rownames(gs.score)='hypoxia.score'
  gs.score=t(gs.score)
  return(gs.score)
}
tcga_hypoxia<-immu_hypoxia(exp_data = tcga_tmp_log2_T)
tcga_hypoxia=crbind2DataFrame(tcga_hypoxia)

tcga_hypoxia.subtype=merge(data.frame(Samples=rownames(tcga_hypoxia),pathway=tcga_hypoxia$hypoxia.score),
                           tcga.subtype,by='Samples')
write.table(tcga_hypoxia.subtype,'results/ana/07.bio.feat/tcga_hypoxia.subtype.txt',quote = F,row.names = F,sep='\t')

tcga_hypoxia.subtype=tcga_hypoxia.subtype[order(tcga_hypoxia.subtype$Cluster),]

fig8f<-sig_violin(dat = tcga_hypoxia.subtype[,c("Cluster","pathway")],
                   leg = 'Senescence Subtype',ylab = 'Hypoxia Score',
                   palette = ggsci::pal_jama()(10))
fig8f

#血管生成
immu_Angiogenesis<-function(exp_data){
  #血管生成相关的基因集，文献来源：PMC3743050
  angiogenesis.sym=c('TEK','CDH5','DLL4','EGFL7','KDR','ROBO4','VWF','TMSB4XP2','EDIL3','PECAM1','CD34','ENG','ESM1','ADGRF5','SELE','PROM1','VEGFA','RAMP2','RGS5','AGGF1','ITGB3','ITGAV','ITGB5','ANGPTL4')
  gs.score=ssGSEAScore_by_genes(exp_data,angiogenesis.sym)
  rownames(gs.score)='angiogenesis.score'
  gs.score=t(gs.score)
  return(gs.score)
}
tcga_Angiogenesis<-immu_Angiogenesis(exp_data = tcga_tmp_log2_T)
tcga_Angiogenesis=crbind2DataFrame(tcga_Angiogenesis)

tcga_Angiogenesis.subtype=merge(data.frame(Samples=rownames(tcga_Angiogenesis),pathway=tcga_Angiogenesis$angiogenesis.score),
                                tcga.subtype,by='Samples')
write.table(tcga_Angiogenesis.subtype,'results/ana/07.bio.feat/tcga_Angiogenesis.subtype.txt',quote = F,row.names = F,sep='\t')

tcga_Angiogenesis.subtype=tcga_Angiogenesis.subtype[order(tcga_Angiogenesis.subtype$Cluster),]

fig8g<-sig_violin(dat = tcga_Angiogenesis.subtype[,c("Cluster","pathway")],
                   leg = 'Senescence Subtype',ylab = 'Angiogenesis Score',
                   palette = ggsci::pal_jama()(10))
fig8g
#ESTIMATE
#tcga_esti<-immu_estimate(exp = tcga_tmp_log2_T,platform='illumina',isTCGA=T)
#save(tcga_esti,file='tcga_esti.RData')
load('tcga_esti.RData')
fig8h<-mg_PlotMutiBoxplot(data = tcga_esti[tcga.subtype$Samples,1:3],
                          group = tcga.subtype$Cluster,
                          group_cols = ggsci::pal_jama()(10),
                          test_method = 'kruskal.test',
                          xangle = 0,
                          add = 'boxplot', 
                          legend.pos = 'top',ylab = 'Immnune score')
fig8h
write.table(tcga_esti,'results/ana/07.bio.feat/tcga_esti.txt',quote = F,sep='\t',row.names = T)

#tcga.cier<-immu_CIBERSORT(exp_data = tcga_tmp_log2_T)
#save(tcga.cier,file='tcga.cier.RData')
load('tcga.cier.RData')
tcga.cier[1:4,1:4]
fig8I<-mg_PlotMutiBoxplot(tcga.cier[tcga.subtype$Samples,1:22],
                          tcga.subtype$Cluster
                          , test_method = 'kruskal.test'
                          , add = 'boxplot'
                          , legend.pos = 'top'
                          , group_cols = ggsci::pal_jama()(10)
                          , ylab = 'Enrichment Score',xangle = 30)
fig8I
write.table(tcga.cier[,1:22],'results/ana/07.bio.feat/tcga.cier.txt',quote = F,sep='\t',row.names = T)

#10个肿瘤相关的通路
#tcga.onco_pathway=immu_oncogenic_pathways(tcga_tmp_log2_T)
#save(tcga.onco_pathway,file='tcga.onco_pathway.RData')
load('tcga.onco_pathway.RData')
fig8j=mg_PlotMutiBoxplot(tcga.onco_pathway[tcga.subtype$Samples,],
                         tcga.subtype$Cluster
                         , test_method = 'kruskal.test'
                         , add = 'boxplot'
                         , legend.pos = 'top'
                         , group_cols = ggsci::pal_jama()(10)
                         , ylab = 'Enrichment Score',xangle = 0)
fig8j
write.table(tcga.onco_pathway,'results/ana/07.bio.feat/tcga.onco_pathway.txt',quote = F,sep='\t',row.names = T)


#炎性因子
immu_inflamatory.response<-function(exp_data){
  #HALLMARK_INFLAMMATORY_RESPONSE :h.all.v7.0.symbols.gmt
  gene=c('CXCL10','CCL2','CCL5','FPR1','CCL20','IL1A','CXCL8','CCL7','CCL22','CXCL11','CCR7','EDN1','CD40','CXCL9','IL6','IL1B','TLR2','IL1R1','CD69','ICAM1','CCRL2','AQP9','EREG','C3AR1','GNA15','CMKLR1','PTGER4','LIF','IL15','NAMPT','OPRK1','ITGB8','PTAFR','ADM','PLAUR','NFKB1','INHBA','OSM','TNFSF10','TNFSF15','IFNGR2','ADGRE1','IL12B','CSF1','CXCL6','TNFRSF9','LYN','ACVR2A','LDLR','BDKRB1','HRH1','F3','BST2','PTGIR','CD55','CALCRL','CSF3','GPR132','IL4R','NLRP3','IL15RA','ADORA2B','GCH1','OLR1','PTGER2','CSF3R','MYC','RELA','TNFAIP6','IL7R','IL18','GABBR1','CD82','TNFSF9','NMUR1','IL2RB','TLR1','LPAR1','IRAK2','RIPK2','MMP14','P2RX7','SLC11A2','SELL','P2RY2','ABCA1','FFAR2','PROK2','GNAI3','TACR1','SLC7A1','CDKN1A','CYBB','TIMP1','HBEGF','SCARF1','EBI3','NFKBIA','SRI','SLC7A2','CCL17','TLR3','APLNR','OSMR','IL10RA','PSEN1','GPR183','ATP2B1','TNFRSF1B','BEST1','GPC3','SCN1B','ACVR1B','HPN','SEMA4D','KLF6','CD48','CXCR6','SLC1A2','GP1BA','TAPBP','RGS16','SLAMF1','LCK','HIF1A','AHR','NMI','RHOG','TPBG','NPFFR2','IFNAR1','ICOSLG','RASGRP1','IFITM1','KCNJ2','LY6E','IL18R1','IL10','KCNA3','HAS2','DCBLD2','LAMP3','VIP','CD70','RGS1','SLC31A1','ADRM1','KCNMB2','SERPINE1','MXD1','AXL','MEFV','PVR','CCL24','PDE4B','LCP2','PDPN','IRF7','MET','ATP2A2','SLC31A2','FZD5','ITGA5','SGMS2','MARCO','CD14','EIF2AK2','ROS1','ATP2C1','NDP','BTG2','MSR1','PTPRE','RNF144B','PCDH7','SPHK1','IL18RAP','RTP4','RAF1','CHST2','ITGB3','KIF1B','SELE','NOD2','C5AR1','EMP3','CLEC5A','TACR3','SLC4A4','MEP1A','SELENOS','LTA','PIK3R5','STAB1','IRF1','ICAM4','P2RX4','ABI1','CX3CL1','SLC28A2')
  gs.score=ssGSEAScore_by_genes(exp_data,gene)
  rownames(gs.score)='inflamatory.response'
  gs.score=t(gs.score)
  return(gs.score)
}

tcga.inflamatory.response=immu_inflamatory.response(tcga_tmp_log2_T)
tcga.inflamatory.response=crbind2DataFrame(tcga.inflamatory.response)
tcga.inflamatory.response.subtype=merge(data.frame(Samples=rownames(tcga.inflamatory.response),pathway=tcga.inflamatory.response$inflamatory.response),
                                        tcga.subtype,by='Samples')
tcga.inflamatory.response.subtype=tcga.inflamatory.response.subtype[order(tcga.inflamatory.response.subtype$Cluster),]

fig8k<-sig_violin(dat = tcga.inflamatory.response.subtype[,c("Cluster","pathway")],
                   leg = 'Senescence Subtype',ylab = 'Inflamatory Response Score',
                   palette = ggsci::pal_jama()(10))

fig8k
write.table(tcga.inflamatory.response.subtype,'results/ana/07.bio.feat/tcga.inflamatory.response.subtype.txt',quote = F,sep='\t',row.names = F)


fig8ae<-mg_merge_plot(fig8a,fig8b,fig8c,fig8d,fig8e,nrow = 1,ncol = 5,labels = LETTERS[1:5],common.legend = T)
fig8fh<-mg_merge_plot(fig8f,fig8g,fig8h,nrow = 1,ncol = 3,widths = c(1,1,3),labels = LETTERS[6:8])
fig8I
fig8jk<-mg_merge_plot(fig8j,fig8k,nrow = 1,ncol = 2,widths = c(3,1),labels = LETTERS[10:11],common.legend = T)
fig8<-mg_merge_plot(fig8ae,fig8fh,fig8I,fig8jk,nrow = 4,ncol = 1,labels = c('','','I',''),common.legend = T)
ggsave('results/ana/07.bio.feat/Fig8.pdf',fig8,height = 15,width = 15)

#9、表型关键基因的鉴定####
dir.create('results/ana/08.module')
#差异分析
tcga.subtype$Cluster1=ifelse(tcga.subtype$Cluster=='clust1','clust1','no_clust1')
tcga.subtype$Cluster2=ifelse(tcga.subtype$Cluster=='clust2','clust2','no_clust2')
tcga.subtype$Cluster3=ifelse(tcga.subtype$Cluster=='clust3','clust3','no_clust3')
gene.type=read.delim('/pub1/data/mg_projects/users/wangtl/public/GeneTag.genecode.v32.txt',sep='\t',header = T)
table(gene.type$TYPE)
gene.type=gene.type[which(gene.type$TYPE=='protein_coding'),"SYMBOL"]
tcga.diff1<-mg_limma_DEG(exp = tcga_tmp_log2_T[intersect(gene.type,rownames(tcga_tmp_log2_T)),
                                               tcga.subtype$Samples],
                         group = tcga.subtype$Cluster1,
                         ulab = 'clust1',dlab = 'no_clust1')
tcga.diff2<-mg_limma_DEG(exp = tcga_tmp_log2_T[intersect(gene.type,rownames(tcga_tmp_log2_T)),
                                               tcga.subtype$Samples],
                         group = tcga.subtype$Cluster2,
                         ulab = 'clust2',dlab = 'no_clust2')
tcga.diff3<-mg_limma_DEG(exp = tcga_tmp_log2_T[intersect(gene.type,rownames(tcga_tmp_log2_T)),
                                               tcga.subtype$Samples],
                         group = tcga.subtype$Cluster3,
                         ulab = 'clust3',dlab = 'no_clust3')
tcga.diff1$Summary
tcga.diff2$Summary
tcga.diff3$Summary

fc_fit=1
p_fit=0.05

tcga.diff1.fit<-tcga.diff1$DEG[which(abs(tcga.diff1$DEG$logFC)>fc_fit & tcga.diff1$DEG$adj.P.Val<p_fit),]
tcga.diff2.fit<-tcga.diff2$DEG[which(abs(tcga.diff2$DEG$logFC)>fc_fit & tcga.diff2$DEG$adj.P.Val<p_fit),]
tcga.diff3.fit<-tcga.diff3$DEG[which(abs(tcga.diff3$DEG$logFC)>fc_fit & tcga.diff3$DEG$adj.P.Val<p_fit),]

write.table(tcga.diff1$DEG,'results/ana/08.module/tcga.diff.clust1.txt',quote = F,row.names = T,sep='\t')
write.table(tcga.diff1$DEG,'results/files/tcga.diff.clust1.txt',quote = F,row.names = T,sep='\t')

write.table(tcga.diff2$DEG,'results/ana/08.module/tcga.diff.clust2.txt',quote = F,row.names = T,sep='\t')
write.table(tcga.diff2$DEG,'results/files/tcga.diff.clust2.txt',quote = F,row.names = T,sep='\t')

write.table(tcga.diff3$DEG,'results/ana/08.module/tcga.diff.clust3.txt',quote = F,row.names = T,sep='\t')
write.table(tcga.diff3$DEG,'results/files/tcga.diff.clust3.txt',quote = F,row.names = T,sep='\t')

table(tcga.diff1.fit$logFC>0)
# FALSE  TRUE 
#127   111
table(tcga.diff2.fit$logFC>0)
# FALSE  TRUE 
#  357     8  
table(tcga.diff3.fit$logFC>0)
# FALSE  TRUE 
#  68   245  

all.diff.gene=unique(c(rownames(tcga.diff1.fit),
                       rownames(tcga.diff2.fit),
                       rownames(tcga.diff3.fit)))
length(all.diff.gene)
#729
write.table(all.diff.gene,'results/ana/08.module/all.diff.gene.txt',quote = F,row.names = F,sep='\t',col.names = F)
write.table(all.diff.gene,'results/files/all.diff.gene.txt',quote = F,row.names = F,sep='\t',col.names = F)

#差异分析火山图
fig9a<-mg_volcano(logfc = tcga.diff1$DEG$logFC,
                  pvalue = tcga.diff1$DEG$adj.P.Val,
                  cutFC = fc_fit,cutPvalue = p_fit,
                  leg = 'clust1 vs no_clust1',legend.pos = 'tr')
fig9a
fig9b<-mg_volcano(logfc = tcga.diff2$DEG$logFC,
                  pvalue = tcga.diff2$DEG$adj.P.Val,
                  cutFC = fc_fit,cutPvalue = p_fit,
                  leg = 'clust2 vs no_clust2',legend.pos = 'tr')
fig9b
fig9c<-mg_volcano(logfc = tcga.diff3$DEG$logFC,
                  pvalue = tcga.diff3$DEG$adj.P.Val,
                  cutFC = fc_fit,cutPvalue = p_fit,
                  leg = 'clust3 vs no_clust3',legend.pos = 'tr')
fig9c
#单因素
coxRun<-function(dat){
  library(survival)
  colnames(dat)=c('time','status','AS')  
  dat=dat[which(!is.na(dat[,1])&!is.na(dat[,3])&!is.na(dat[,2])),]
  #print(nrow(dat))
  if(nrow(dat)<10){
    print(paste0('Sample Num is small:',nrow(dat)))
    return(c(NA,NA,NA,NA))
  }
  #if(quantile(dat[,3])['25%']==quantile(dat[,3])['50%']) return(c(NA,NA,NA,NA))
  fmla <- as.formula("Surv(time, status) ~AS")
  if(table(dat[,2])[1]>1&table(dat[,2])[2]>1){
    cox <- survival::coxph(fmla, data = dat)
    re=c(summary(cox)[[7]][5],summary(cox)[[7]][2],summary(cox)[[8]][3],summary(cox)[[8]][4])
    return(re)
  }else{
    return(c(NA,NA,NA,NA))
  }
}
cox_batch<-function(dat,time,event){
  t.inds=which(!is.na(time)&!is.na(event))
  dat1=dat[,t.inds]
  os=time[t.inds]
  ev=event[t.inds]
  
  ct=sum(ev%in%c(0,1))
  if(ct!=length(ev)){
    print('event must be 0(alive) or 1(dead)')
    return(NULL)
  }
  
  res=t(apply(dat1, 1, function(x){
    ep=as.numeric(as.character(x))
    ind2=which(!is.na(ep))
    print(length(ind2))
    if(length(ind2)>1){
      os1=os[ind2]
      ev1=ev[ind2]
      ep1=ep[ind2]
      return(coxRun(data.frame(os1,ev1,ep1)))
    }else{
      return(c(NA,NA,NA,NA))
    }
  }))
  colnames(res)=c('p.value','HR','Low 95%CI','High 95%CI')
  row.names(res)=row.names(dat1)
  return(as.data.frame(res))
}

mg_risksocre.sig<-function(dat,os,os.time){
  #dat=tcga_cellage.exp_for
  #os=tcga_cli$OS
  #os.time=tcga_cli$OS.time
  tcga_dat_m<-cbind.data.frame(os=os,os.time=os.time,dat)
  tcga.cox <- cox_batch(t(tcga_dat_m[,3:ncol(tcga_dat_m)]),
                        time = tcga_dat_m$os.time,
                        event = tcga_dat_m$os)
  
  return(tcga.cox)
}

get_riskscore.lasso<-function(dat,os,os.time,labels=c('A','B')){
  library(glmnet)
  set.seed(2021)
  options(ggrepel.max.overlaps=Inf)
  fit1=glmnet(as.matrix(dat)
              ,cbind(time=os.time,
                     status=os)
              ,family="cox"
              ,nlambda=100
              , alpha=1) 
  
  cv.fit<-cv.glmnet(as.matrix(dat)
                    ,cbind(time=os.time,
                           status=os)
                    ,family="cox"
                    ,nfolds = 10,
                    ,nlambda=100
                    , alpha=1)
  sig.coef <- coefficients(cv.fit,s=cv.fit$lambda.min)[which(coefficients(cv.fit,s=cv.fit$lambda.min)[,1]!=0),1]
  #print(cv.fit$lambda.min)
  #length(names(sig.coef))
  #10
  mg_plot_lasso <- function(fit,cv_fit,lambda=NULL,show_text=T,figLabels=c('A','B')){
    if(is.null(lambda)){
      lmda=cv_fit$lambda.min
    }else{
      lmda=lambda
    }
    fit.coef=fit$beta[(apply(fit$beta,1,function(x){
      return(sum(x!=0))
    })>0),]
    
    fit.coef=as.matrix(fit.coef)
    colnames(fit.coef)=fit$lambda
    #fit$lambda==cv_fit$lambda
    library(ggplot2)
    dat=data.table::melt(t(as.matrix(fit.coef)))
    dat_z=dat[which(dat$value==0),]
    dat=dat[which(dat$value!=0),]
    dat.sv=rbind()
    for (u in unique(dat_z[,2])) {
      t.z=dat_z[which(dat_z[,2]==u),1]
      t.zx=max(t.z)
      dat.sv=rbind(dat.sv,c(t.zx,u,0))
      t.zn=min(t.z)
      if(t.zx!=t.zn){
        dat.sv=rbind(dat.sv,c(t.zn,u,0))
      }
    }
    colnames(dat.sv)=colnames(dat_z)
    #dat_z=dat_z[dat_z[,2]%in%names(which(fit.coef[,which(fit$lambda==lmda)]!=0)),]
    dat=crbind2DataFrame(rbind(dat,dat.sv))
    mn=min(-log(dat$Var1))
    mx=max(-log(dat$Var1))
    if(show_text){
      mx=(mx-mn)*0.1+mx
    }
    p=ggplot(dat, aes(x=-log(Var1), y=value,colour=Var2))+geom_line()+theme_bw()+theme(legend.position = "none")
    p=p+coord_cartesian(xlim=c(mn, mx))+xlab('-ln(lambda)')+ylab('Coefficients')
    if(show_text){
      fl=fit.coef[which(fit.coef[,which(fit$lambda==lmda)]!=0),ncol(fit.coef)]
      for_label=data.frame(Var1=rep(min(dat$Var1),length(fl)),Var2=names(fl),value=fl)
      p=p+ggrepel::geom_label_repel(
        aes(label = Var2,color=Var2),
        data = for_label,hjust = 0
      )
    }
    p=p+geom_vline(aes(xintercept=-log(lmda)), colour="#BB0000", linetype="dashed")
    p=p+annotate('text',x=-log(lmda),y=min(dat[,3]),label=paste0('lambda=',round(lmda,4)))
    tgc=data.frame(lambda=cv_fit$lambda,cvm=cv_fit$cvm,cvup=cv_fit$cvup,cvlo=cv_fit$cvlo,cvsd=cv_fit$cvsd
                   ,col=ifelse(cv_fit$lambda>=cv_fit$lambda.min&cv_fit$lambda<=cv_fit$lambda.1se,ifelse(cv_fit$lambda==lmda,'A','C'),'B'))
    p1=ggplot(tgc, aes(x=log(lambda), y=cvm)) + xlab('ln(lambda)')+ ylab('Parial Likelihood Deviance')+
      geom_errorbar(aes(ymin=cvm-cvsd, ymax=cvm+cvsd)) +
      geom_point(aes(colour=col))
    p1=p1+theme_bw()+theme(legend.position = "none")
    gal=ggpubr::ggarrange(p,p1, ncol = 2, nrow = 1
                          #,align = "hv"
                          ,labels = figLabels)
    return(gal)
  }
  lasso.pdf <- mg_plot_lasso(fit1,
                             cv.fit,
                             show_text=T,
                             figLabels=labels)
  return(list(lasso.gene=sig.coef,lambda.min=cv.fit$lambda.min,plot=lasso.pdf))
}
get_riskscore<-function(dat,os,os.time,step=T,direction=c("both", "backward", "forward")[1]){
  tcga_dat1 <- cbind(time=os.time,
                     status=os,
                     dat)
  tcga_dat1=crbind2DataFrame(tcga_dat1)
  colnames(tcga_dat1)=gsub('-','__',colnames(tcga_dat1))
  gene111=gsub('-','__',colnames(dat))
  fmla <- as.formula(paste0("Surv(time, status) ~"
                            ,paste0(gene111,collapse = '+')))
  cox <- coxph(fmla, data =as.data.frame(tcga_dat1))
  if(step==T){
    cox1 <- step(cox,direction =direction)
  }else{
    cox1=cox
  }
  lan <- coef(cox1)
  #round(lan, 3)
  genes <- names(cox1$coefficients)
  mult_results=paste0(round(lan, 3), '*', names(lan),collapse = '+')
  risk.tcga <- as.numeric(lan%*%as.matrix(t(tcga_dat1[,genes])))
  
  data_gene_score_final<-tcga_dat1
  data_gene_score_final$Samples<-rownames(data_gene_score_final)
  data_gene_score_final$riskscore=risk.tcga
  data_gene_score_final$riskscorez=mosaic::zscore(risk.tcga)
  optimalCutoff <- survminer::surv_cutpoint(data.frame(time=data_gene_score_final$time/365,
                                                       event=data_gene_score_final$status,
                                                       risk=data_gene_score_final$riskscore), 
                                            time = "time", event = "event",variables = c("risk"))
  optimalCutoff=optimalCutoff$cutpoint$cutpoint[1]
  #print(optimalCutoff)
  #optimalCutoff=median(data_gene_score_final$riskscore)
  #optimalCutoff=0
  data_gene_score_final$Risk=ifelse(data_gene_score_final$riskscore>optimalCutoff,'High','Low')
  table(data_gene_score_final$Risk)
  data_gene_score_final$cutoff=optimalCutoff
  return(list(result=data_gene_score_final,module.gene=cox1$coefficients,model=mult_results))
}

#单因素cox分析
tcga_tmp_log2.1=tcga_tmp_log2_T
rownames(tcga_tmp_log2.1)=gsub('-','__',rownames(tcga_tmp_log2.1))
all.diff.gene.1=gsub('-','__',all.diff.gene)

tcga_diff.exp<-t(tcga_tmp_log2.1[all.diff.gene.1,tcga_subtype.cli$Samples])
tcga.cox <- mg_risksocre.sig(dat = tcga_diff.exp,
                             os = tcga_subtype.cli$OS,
                             os.time = tcga_subtype.cli$OS.time)


cox.p.fit=0.005
tcga.cox.fit<-tcga.cox[tcga.cox$p.value<cox.p.fit,]
dim(tcga.cox.fit)#220
tcga.cox$coef=log(tcga.cox$HR)
tcga.cox$Gene=rownames(tcga.cox)
tcga.cox$type=rep('None',nrow(tcga.cox))
tcga.cox$type[which(tcga.cox$p.value<cox.p.fit & tcga.cox$coef>0)]='Risk'
tcga.cox$type[which(tcga.cox$p.value<cox.p.fit & tcga.cox$coef<0)]='Protective'
fig9d <- ggplot(data = tcga.cox,
                aes(x = coef,
                    y = -log10(p.value)))+
  geom_point(alpha=0.4, size=3.5, aes(color=type))+
  scale_color_manual(values=c(mg_colors[2],'grey',mg_colors[1]),
                     limits = c("Protective",'None', "Risk"),name='State')+
  geom_hline(yintercept = -log10(cox.p.fit),lty=4,col="black",lwd=0.8)+
  ylab('-log10(pvalue)')+xlab('Cox coefficient')+
  theme_bw()+
  theme(axis.text.y=element_text(family="Times",face="plain"), #设置y轴刻度标签的字体簇，字体大小，字体样式为plain
        axis.title.y=element_text(family="Times",face="plain"), #设置y轴标题的字体属性
        legend.text=element_text(face="plain", family="Times", colour="black"),  #设置图例的子标题的字体属性
        legend.title=element_text(face="plain", family="Times", colour="black" ),#设置图例的总标题的字体属性
        legend.justification=c(1,1), legend.position=c(1,1),
        legend.background = element_rect(fill = NA, colour = NA)
  )
# +ggrepel::geom_text_repel(data=module.genes.cox_use[which(module.genes.cox_use$p.value<0.05),],aes(label=Gene))
fig9d
table(tcga.cox$type)
# None Protective       Risk 
# 509         26        194 
write.table(tcga.cox,'results/ana/08.module/tcga.cox.txt',quote = F,row.names = F,sep='\t')
write.table(tcga.cox,'results/files/tcga.cox.txt',quote = F,row.names = F,sep='\t')


tcga.lasso<-get_riskscore.lasso(dat = tcga_diff.exp[,rownames(tcga.cox.fit)],
                                os=tcga_subtype.cli$OS,
                                os.time = tcga_subtype.cli$OS.time,
                                labels=c('E','F'))

length(names(tcga.lasso$lasso.gene))#7

tcga.lasso$lambda.min
# 0.08299557
tcga.module.risk<-get_riskscore(dat=tcga_diff.exp[,names(tcga.lasso$lasso.gene)],
                                #dat=tcga_diff.exp[,rownames(tcga.cox.fit)],
                                os=tcga_subtype.cli$OS,
                                os.time=tcga_subtype.cli$OS.time,
                                step=F,
                                direction=c("both", "backward", "forward")[1])

length(names(tcga.module.risk$module.gene))#7
names(tcga.module.risk$module.gene)
#CDCA8" "G6PD"  "ADH4"  "CFHR3" "KPNA2" "RAMP3" "PON1
tcga.module.risk$model
#"0.099*CDCA8+0.114*G6PD+-0.024*ADH4+-0.057*CFHR3+0.164*KPNA2+-0.15*RAMP3+-0.037*PON1"
#柱状图
gene.coef=as.data.frame(tcga.module.risk$module.gene)
gene.coef=data.frame(Gene=rownames(gene.coef),Coef=gene.coef[,1])
gene.coef$Type=ifelse(gene.coef$Coef>0,'Risk','Protective')
gene.coef$Type=factor(gene.coef$Type,levels=c('Risk','Protective'))
library(dplyr)
fig9e=gene.coef %>% 
  ggplot(aes(reorder(Gene, Coef), Coef)) +
  geom_col(aes(fill = Type)) +
  coord_flip() +
  scale_fill_manual(values=ggsci::pal_lancet('lanonc',alpha =0.6)(9)[c(7,1)]) +
  coord_flip() +
  labs(x = "") +
  labs(y = "Cox coefficient") +
  theme(axis.text.y = element_text(angle = 0, hjust = 1),legend.position="top")
fig9e
fig9abc<-mg_merge_plot(fig9a,fig9b,fig9c,nrow = 1,ncol = 3,labels = c('A','B','C'))
fig9defg<-mg_merge_plot(fig9d,tcga.lasso$plot,fig9e,nrow = 1,ncol = 3,labels = c('D','','G'),widths = c(1,2,1))
fig9<-mg_merge_plot(fig9abc,fig9defg,nrow = 2,ncol = 1,heights = c(1.1,1))
ggsave('results/ana/08.module/Fig9.pdf',fig9,height = 8,width = 12)
ggsave('results/ana/08.module/Fig9.jpg',fig9,height = 8,width = 12,dpi = 300)
saveTiff('results/ana/08.module/Fig9.tif',fig9,height = 8,width = 12)

fig10a1<-ggplotTimeROC(time = tcga.module.risk$result$time/365
                      ,status = tcga.module.risk$result$status
                      ,score = tcga.module.risk$result$riskscore
                      ,mks = c(1,2,3,4,5))
fig10a1
fig10a2<-ggplotKMCox(dat = data.frame(tcga.module.risk$result$time/365,
                                     tcga.module.risk$result$status,
                                     #tcga.module.risk$result$Risk
                                     ifelse(tcga.module.risk$result$riskscorez>=0,'H','L')),
                    title = 'TCGA Senescore',add_text = '',
                    palette = ggsci::pal_npg()(10),labs = c('High','Low'))

fig10a2
tcga.module.risk$result$Risk=ifelse(tcga.module.risk$result$riskscorez>=0,'High','Low')
fig10a=mg_merge_plot(fig10a1,fig10a2,nrow = 2,ncol = 1)
fig10a
#独立数据集验证
hccd.module.risk<-get_riskscore(dat = t(HCCDB18_exp[intersect(names(tcga.module.risk$module.gene),
                                                              rownames(HCCDB18_exp)),
                                                    HCCDB18_cli$Samples]),
                                os =HCCDB18_cli$OS,
                                os.time = HCCDB18_cli$OS.time,
                                step=F,direction=c("both", "backward", "forward")[1])

fig10b1<-ggplotTimeROC(time = hccd.module.risk$result$time/365
                       ,status = hccd.module.risk$result$status
                       ,score = hccd.module.risk$result$riskscorez
                       ,mks = c(1,2,3,4,5))
fig10b1
fig10b2<-ggplotKMCox(dat = data.frame(hccd.module.risk$result$time/365,
                                      hccd.module.risk$result$status,
                                      ifelse(hccd.module.risk$result$riskscorez>=0,'H','L')),
                     title = 'HCCDB18',add_text = '',
                     palette = ggsci::pal_npg()(9),labs = c('High','Low'))
hccd.module.risk$result$Risk=ifelse(hccd.module.risk$result$riskscorez>=0,'High','Low')

fig10b=mg_merge_plot(fig10b1,fig10b2,nrow = 2,ncol = 1)
fig10b
#GSE14520
gse14520.module.risk<-get_riskscore(dat = t(GSE14520_exp[intersect(names(tcga.module.risk$module.gene),rownames(GSE14520_exp)),
                                                         GSE14520_cli$Samples]),
                                    os =GSE14520_cli$OS,
                                    os.time = GSE14520_cli$OS.time,
                                    step=F,direction=c("both", "backward", "forward")[1])

fig10c1<-ggplotTimeROC(time = gse14520.module.risk$result$time/365
                       ,status = gse14520.module.risk$result$status
                       ,score = gse14520.module.risk$result$riskscorez
                       ,mks = c(1,2,3,4,5))
fig10c1
fig10c2<-ggplotKMCox(dat = data.frame(gse14520.module.risk$result$time/365,
                                      gse14520.module.risk$result$status,
                                      ifelse(gse14520.module.risk$result$riskscorez>=0,'H','L')),
                     title = 'GSE14520',add_text = '',
                     palette = ggsci::pal_npg()(9),labs = c('High','Low'))
gse14520.module.risk$result$Risk=ifelse(gse14520.module.risk$result$riskscorez>=0,'High','Low')

fig10c=mg_merge_plot(fig10c1,fig10c2,nrow = 2,ncol = 1)
fig10c
#GSE76427
gse76427.module.risk<-get_riskscore(dat = t(GSE76427_exp[intersect(names(tcga.module.risk$module.gene),rownames(GSE76427_exp)),
                                                         GSE76427_cli$Samples]),
                                    os =GSE76427_cli$OS,
                                    os.time = GSE76427_cli$OS.time,
                                    step=F,direction=c("both", "backward", "forward")[1])

fig10d1<-ggplotTimeROC(time = gse76427.module.risk$result$time/365
                       ,status = gse76427.module.risk$result$status
                       ,score = gse76427.module.risk$result$riskscorez
                       ,mks = c(1,2,3,4,5))

fig10d2<-ggplotKMCox(dat = data.frame(gse76427.module.risk$result$time/365,
                                      gse76427.module.risk$result$status,
                                      ifelse(gse76427.module.risk$result$riskscorez>=0,'H','L')),
                     title = 'GSE76427',add_text = '',
                     palette = ggsci::pal_npg()(9),labs = c('High','Low'))
gse76427.module.risk$result$Risk=ifelse(gse76427.module.risk$result$riskscorez>=0,'High','Low')

fig10d=mg_merge_plot(fig10d1,fig10d2,nrow = 2,ncol = 1)
fig10d
fig10<-mg_merge_plot(fig10a,fig10b,fig10d,nrow = 1,ncol = 3,labels = LETTERS[1:3])
ggsave('results/ana/08.module/Fig10.pdf',fig10,height = 9,width = 12)

write.table(tcga.module.risk$result[,c("Samples","riskscore","riskscorez","Risk")],
            'results/ana/08.module/tcga.module.risk.txt',quote = F,sep='\t',row.names = F)
write.table(hccd.module.risk$result[,c("Samples","riskscore","riskscorez","Risk")],
            'results/ana/08.module/hccdb18.module.risk.txt',quote = F,sep='\t',row.names = F)
write.table(gse76427.module.risk$result[,c("Samples","riskscore","riskscorez","Risk")],
            'results/ana/08.module/gse76427.module.risk.txt',quote = F,sep='\t',row.names = F)
#10.风险模型临床表型的差异分析####
dir.create('results/ana/09.module.cli')
head(tcga_subtype.cli)
tcga_subtype.cli.risk<-merge(tcga_subtype.cli,
                             tcga.module.risk$result[,c("Samples","riskscore","riskscorez","Risk")],
                             by='Samples')
head(tcga_subtype.cli.risk)
write.table(tcga_subtype.cli.risk,'results/ana/09.module.cli/tcga_subtype.cli.risk.txt',quote = F,row.names = F,sep='\t')

table(tcga_subtype.cli$Gender)
fig11a<-sig_violin(dat = tcga_subtype.cli.risk[,c("Gender","riskscore")],
                    leg = 'Gender',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
fig11a

fig11b<-sig_violin(dat = tcga_subtype.cli.risk[,c("T.Stage","riskscore")],
                    leg = 'T.Stage',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
fig11b
# fig11c<-sig_boxplot(dat = tcga_subtype.cli.risk[,c("N.Stage","riskscore")],
#                     leg = 'N.Stage',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
# fig11c
# fig11d<-sig_boxplot(dat = tcga_subtype.cli.risk[,c("M.Stage","riskscore")],
#                     leg = 'M.Stage',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
# fig11d
fig11e<-sig_violin(dat = tcga_subtype.cli.risk[,c("Stage","riskscore")],
                    leg = 'Stage',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
fig11e
fig11f<-sig_violin(dat = tcga_subtype.cli.risk[,c("Age1","riskscore")],
                  leg = 'Age',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
fig11f
fig11g<-sig_violin(dat = tcga_subtype.cli.risk[,c("Grade","riskscore")],
                    leg = 'Grade',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
fig11g
fig11h<-sig_violin(dat = tcga_subtype.cli.risk[,c("Cluster","riskscore")],
                    leg = 'Senescence Subtype',ylab = 'Senescore',palette = ggsci::pal_d3()(9))
fig11h

fig11<-mg_merge_plot(fig11a,fig11b,
                     fig11e,fig11f,fig11g,fig11h,nrow = 2,ncol = 3)
ggsave('results/ana/09.module.cli/Fig11.pdf',fig11,height = 9,width = 12)
table(tcga_subtype.cli$N.Stage)
table(tcga_subtype.cli$M.Stage)
table(tcga_subtype.cli$Stage)

#11、单因素和多因素+列线图#####
dir.create('results/ana/10.module.sigmut')
library(forestplot)
library(survcomp)
tcga_cox_datas <- tcga_subtype.cli.risk
tcga_cox_datas <- crbind2DataFrame(tcga_cox_datas)

tcga_cox_datas$RiskType=tcga_cox_datas$Risk
table(tcga_cox_datas$RiskType)
tcga_cox_datas$RiskType <- ifelse(tcga_cox_datas$RiskType == 'High', '1High', '0Low')

table(tcga_cox_datas$T.Stage)
tcga_cox_datas$T.Stage[tcga_cox_datas$T.Stage == 'T1' | tcga_cox_datas$T.Stage == 'T2'] <- 'T1+T2'
tcga_cox_datas$T.Stage[tcga_cox_datas$T.Stage == 'T3' | tcga_cox_datas$T.Stage == 'T4'] <- 'T3+T4'

table(tcga_cox_datas$N.Stage)
#tcga_cox_datas$N.Stage[tcga_cox_datas$N.Stage == 'N1' | tcga_cox_datas$N.Stage == 'N2' | tcga_cox_datas$N.Stage == 'N3'] <- 'N1+N2+N3'
table(tcga_cox_datas$M.Stage)

table(tcga_cox_datas$Stage)
tcga_cox_datas$Stage[tcga_cox_datas$Stage == 'I' | tcga_cox_datas$Stage == 'II'] <- 'I+II'
tcga_cox_datas$Stage[tcga_cox_datas$Stage == 'III' | tcga_cox_datas$Stage == 'IV'] <- 'III+IV'

table(tcga_cox_datas$Grade)
tcga_cox_datas$Grade[tcga_cox_datas$Grade=='G1'|tcga_cox_datas$Grade=='G2']<-'G1+G2'
tcga_cox_datas$Grade[tcga_cox_datas$Grade=='G3'|tcga_cox_datas$Grade=='G4']<-'G3+G4'
table(tcga_cox_datas$Grade)

write.table(tcga_cox_datas,'results/ana/10.module.sigmut/tcga_cox_datas.txt',quote = F,sep = '\t',row.names = F)
# 单因素分析结果 
Age_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~Age,
                             data=tcga_cox_datas))
Age_sig_cox_dat <- data.frame(Names=rownames(Age_sig_cox[[8]]),
                              HR = round(Age_sig_cox[[7]][,2],3),
                              lower.95 = round(Age_sig_cox[[8]][,3],3),
                              upper.95 = round(Age_sig_cox[[8]][,4],3),
                              p.value=round(Age_sig_cox[[7]][,5],3))
Age_sig_cox_dat

Gender_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~Gender,
                                data=tcga_cox_datas))
Gender_sig_cox_dat <- data.frame(Names=rownames(Gender_sig_cox[[8]]),
                                 HR = round(Gender_sig_cox[[7]][,2],3),
                                 lower.95 = round(Gender_sig_cox[[8]][,3],3),
                                 upper.95 = round(Gender_sig_cox[[8]][,4],3),
                                 p.value=round(Gender_sig_cox[[7]][,5],3))
Gender_sig_cox_dat

A3_T_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~T.Stage,
                              data=tcga_cox_datas))
A3_T_sig_cox_dat <- data.frame(Names=rownames(A3_T_sig_cox[[8]]),
                               HR = round(A3_T_sig_cox[[7]][,2],3),
                               lower.95 = round(A3_T_sig_cox[[8]][,3],3),
                               upper.95 = round(A3_T_sig_cox[[8]][,4],3),
                               p.value=round(A3_T_sig_cox[[7]][,5],3))
A3_T_sig_cox_dat

A4_N_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~N.Stage,
                              data=tcga_cox_datas))
A4_N_sig_cox_dat <- data.frame(Names=rownames(A4_N_sig_cox[[8]]),
                               HR = round(A4_N_sig_cox[[7]][,2],3),
                               lower.95 = round(A4_N_sig_cox[[8]][,3],3),
                               upper.95 = round(A4_N_sig_cox[[8]][,4],3),
                               p.value=round(A4_N_sig_cox[[7]][,5],3))
A4_N_sig_cox_dat

A5_M_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~M.Stage,
                              data=tcga_cox_datas))
A5_M_sig_cox_dat <- data.frame(Names=rownames(A5_M_sig_cox[[8]]),
                               HR = round(A5_M_sig_cox[[7]][,2],3),
                               lower.95 = round(A5_M_sig_cox[[8]][,3],3),
                               upper.95 = round(A5_M_sig_cox[[8]][,4],3),
                               p.value=round(A5_M_sig_cox[[7]][,5],3))
A5_M_sig_cox_dat


Stage_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~Stage,
                               data=tcga_cox_datas))
Stage_sig_cox_dat <- data.frame(Names=rownames(Stage_sig_cox[[8]]),
                                HR = round(Stage_sig_cox[[7]][,2],3),
                                lower.95 = round(Stage_sig_cox[[8]][,3],3),
                                upper.95 = round(Stage_sig_cox[[8]][,4],3),
                                p.value=round(Stage_sig_cox[[7]][,5],3))
Stage_sig_cox_dat

Grade_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~Grade,
                               data=tcga_cox_datas))
Grade_sig_cox_dat <- data.frame(Names=rownames(Grade_sig_cox[[8]]),
                                HR = round(Grade_sig_cox[[7]][,2],3),
                                lower.95 = round(Grade_sig_cox[[8]][,3],3),
                                upper.95 = round(Grade_sig_cox[[8]][,4],3),
                                p.value=round(Grade_sig_cox[[7]][,5],3))
Grade_sig_cox_dat


RiskType_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~riskscore,
                                  data=tcga_cox_datas))
RiskType_sig_cox_dat <- data.frame(Names=rownames(RiskType_sig_cox[[8]]),
                                   HR = round(RiskType_sig_cox[[7]][,2],3),
                                   lower.95 = round(RiskType_sig_cox[[8]][,3],3),
                                   upper.95 = round(RiskType_sig_cox[[8]][,4],3),
                                   p.value=round(RiskType_sig_cox[[7]][,5],3))
RiskType_sig_cox_dat

sig_cox_dat <- rbind(Age_sig_cox_dat,
                     Gender_sig_cox_dat,
                     #A3_T_sig_cox_dat,
                     #A4_N_sig_cox_dat,
                     #A5_M_sig_cox_dat,
                     Stage_sig_cox_dat,
                     Grade_sig_cox_dat,
                     RiskType_sig_cox_dat)

data.sig <- data.frame(Names=sig_cox_dat$Names,
                       p.value=sig_cox_dat$p.value,
                       sig_cox_dat$HR,
                       sig_cox_dat$lower.95,
                       sig_cox_dat$upper.95)
data.sig <- crbind2DataFrame(data.sig)
data.sig$Names
rownames(data.sig) <- c("Age",
                        "Gender",
                        #"T.Stage",
                        #"N.Stage",
                        #"M.Stage",
                        "Stage",
                        "Grade",
                        "Senescore")
data.sig$Names <- rownames(data.sig)
data.sig$p.value=ifelse(data.sig$p.value==0.000,'<0.0001',data.sig$p.value)
data.sig
pdf('results/ana/10.module.sigmut/Fig12A.pdf', width = 8, height = 5,onefile = F)
mg_forestplot_v2(data.sig,xlog = T,colgap = 8,lineheight = 10)
dev.off()
#多因素分析结果
muti_sig_cox <- summary(coxph(formula=Surv(OS.time, OS)~Age+Gender+Stage+Grade+riskscore, data=tcga_cox_datas))

muti_cox_dat <- data.frame(Names=rownames(muti_sig_cox[[8]]),
                           HR = round(muti_sig_cox[[7]][,2],3),
                           lower.95 = round(muti_sig_cox[[8]][,3],3),
                           upper.95 = round(muti_sig_cox[[8]][,4],3),
                           p.value=round(muti_sig_cox[[7]][,5],3))
data.muti <- data.frame(Names=muti_cox_dat$Names,
                        p.value=muti_cox_dat$p.value,
                        muti_cox_dat$HR,
                        muti_cox_dat$lower.95,
                        muti_cox_dat$upper.95)
data.muti <- crbind2DataFrame(data.muti)
rownames(data.muti) <- c("Age",
                         "Gender",
                         #"T.Stage",
                         #"N.Stage",
                         #"M.Stage",
                         "Stage",
                         "Grade",
                         "Senescore")
data.muti$Names <- rownames(data.muti)
data.muti$p.value=ifelse(data.muti$p.value==0.000,'<0.0001',data.muti$p.value)
data.muti
pdf('results/ana/10.module.sigmut/Fig12B.pdf', width = 8, height = 5,onefile = F)
mg_forestplot_v2(data.muti,xlog = T,colgap = 8,lineheight = 10)
dev.off()
#列线图
mg_nomogram=function(clinical_riskscore,
                     os,
                     status,
                     title='Nomogram',
                     quick=T,
                     mks = c(1,3,5)){
  #clinical_riskscore=dat1[,3:5]
  #os=dat1[,1]
  #status=dat1[,2]
  #sum(is.na(norm.stat.al[,3]))
  norm.stat.al=data.frame(clinical_riskscore,time=os,status=status)
  norm.stat.al=as.data.frame(norm.stat.al)
  library(rms)
  env <- globalenv()
  env$MG_Grobal_DDSet <- rms::datadist(norm.stat.al) 
  options(datadist='MG_Grobal_DDSet')
  fmla <- as.formula(paste0("Surv(time, status) ~",paste0(colnames(clinical_riskscore),collapse = '+')))
  cox2 <- cph(fmla, data = norm.stat.al,surv = T,x = T,y = T)
  #summary(cox2)
  #surv=Survival(cox2)
  
  fp <- predict(cox2)
  cindex=getC_index(fp,norm.stat.al$time,norm.stat.al$status)
  #cindex.orig=1-rcorr.cens(fp,Surv(norm.stat.al$time,norm.stat.al$status))
  cut.time=c()
  if(quantile(os[!is.na(os)])['75%']<12){
    cut.time=mks
  }else if(quantile(os[!is.na(os)])['75%']<365){
    cut.time=c(12*mks[1],12*mks[2],12*mks[3])
  }else{
    cut.time=c(365*mks[1],365*mks[2],365*mks[3])
  }
  cut.time=cut.time[which(cut.time<quantile(os,seq(0,1,0.01))['100%'])]
  print(cut.time)
  #regplot(cox2)
  #  print(regplot(cox3#对观测2的六个指标在列线图上进行计分展示
  #,observation=pbc[2,] #也可以不展示
  #预测3年和5年的死亡风险，此处单位是day
  #              ,title=title
  #              ,failtime = cut.time
  #              ,prfail = TRUE #cox回归中需要TRUE
  #              ,showP = T #是否展示统计学差异
  #              ,droplines = F#观测2示例计分是否画线
  #,colors = mg_colors[1:3] #用前面自己定义的颜色
  #,rank="decreasing") #根据统计学差异的显著性进行变量的排序
  #,interval="confidence"
  #,rank="decreasing"
  #,clickable=T
  #              ,points=TRUE)) #展示观测的可信区间
  
  #  plot(nom)
  surv=Survival(cox2)
  survs=list()
  cal_all=list()
  for(i in 1:length(cut.time)){
    f1<-cph(formula = fmla,data=norm.stat.al,x=T,y=T,surv = T,na.action=na.delete,time.inc = cut.time[i]) 
    cal1<-calibrate(f1, cmethod="KM", method="boot",u=cut.time[i],m=floor(sum(f1$n)/3)) 
    cal_all=c(cal_all,list(cal1))
    #    surv0 <- function(x)surv(cut.time[i],lp=x) 
    #    survs=c(survs,list(surv0))
  }
  #f2<-cph(formula = fmla,data=norm.stat.al,x=T,y=T,surv = T,na.action=na.delete,time.inc = cut.time[2]) 
  #cal3<-calibrate(f2, cmethod="KM", method="boot",u=cut.time[2],m=100,B=200) 
  #f3<-cph(formula = fmla,data=norm.stat.al,x=T,y=T,surv = T,na.action=na.delete,time.inc = cut.time[3]) 
  #cal5<-calibrate(f3, cmethod="KM", method="boot",u=cut.time[3],m=100,B=200) 
  if(length(cut.time)==1){
    surv1 <- function(x)surv(cut.time[1],lp=x) 
    survs=list(surv1)
  }else if(length(cut.time)==2){
    surv1 <- function(x)surv(cut.time[1],lp=x) 
    surv2 <- function(x)surv(cut.time[2],lp=x) 
    survs=list(surv1,surv2)
  }else if(length(cut.time)==3){
    surv1 <- function(x)surv(cut.time[1],lp=x) 
    surv2 <- function(x)surv(cut.time[2],lp=x) 
    surv3 <- function(x)surv(cut.time[3],lp=x) 
    survs=list(surv1,surv2,surv3)
  }
  nom=nomogram(cox2,fun=survs,lp= F
               ,funlabel=c(paste0(mks[1], '-Year Survival'),
                           paste0(mks[2], '-Year Survival'),
                           paste0(mks[3], '-Year Survival'))[1:length(cut.time)]
               ,maxscale=100
               ,fun.at=seq(0,1,0.2)
  )
  
  if(!quick){
    cal_all=list()
    for(i in 1:length(cut.time)){
      cal1=get_best_calibrate(cox2,cut.time[i])
      cal_all=c(cal_all,list(cal1))
    }
    #cal3=get_best_calibrate(cox2,cut.time[2])
    #cal5=get_best_calibrate(cox2,cut.time[3])
  }
  lay2 <- customLayout::lay_new(matrix(1:2))
  lay1 <- customLayout::lay_new(matrix(1:1))
  cl <- customLayout::lay_bind_col(lay2, lay1, widths = c(1, 1.5)) 
  #customLayout::lay_show(cl)
  customLayout::lay_set(cl) 
  
  plot(cal_all[[1]],lwd = 2,lty = 1,errbar.col = mg_colors[1], bty = "l",xlim = c(0,1),ylim= c(0,1),xlab = "Nomogram-prediced OS (%)"
       ,ylab = "Observed OS (%)",col = mg_colors[1],cex.lab=1.2,cex.axis=1, cex.main=1.2, cex.sub=0.6,subtitles = F)
  #lines(cal_all[[1]][,c('mean.predicted',"KM")],type = 'b', lwd = 1, col = mg_colors[1], pch = 16)
  mtext("")
  if(length(cal_all)>1){
    for(i in 2:length(cal_all)){
      plot(cal_all[[i]],lwd = 2,lty = 1,errbar.col = mg_colors[i],xlim = c(0,1),ylim= c(0,1),col = mg_colors[i],add = T)
      #lines(cal_all[[i]][,c('mean.predicted',"KM")],type = 'b', lwd = 1, col = mg_colors[i], pch = 16)
    }
    #plot(cal3,lwd = 2,lty = 0,errbar.col = mg_colors[3],xlim = c(0,1),ylim= c(0,1),col = mg_colors[3],add = T)
    #lines(cal3[,c('mean.predicted',"KM")],type = 'b', lwd = 1, col = mg_colors[3], pch = 16)
  }
  abline(0,1, lwd = 2, lty = 3, col = 'black')
  legend("topleft", legend = c(paste0(mks[1], '-Year'),
                               paste0(mks[2], '-Year'),
                               paste0(mks[3], '-Year'))[1:length(cut.time)],col =mg_colors[1:length(cut.time)],lwd = 2,cex = 1.2,bty = "n")
  
  fp <- predict(cox2)
  cindex=getC_index(fp,norm.stat.al$time,norm.stat.al$status)
  dca_dat=data.frame(Nomogram=fp,status=norm.stat.al$status)
  fp.al=cbind(fp)
  for(i in 1:ncol(clinical_riskscore)){
    fmla1 <- as.formula(paste0("Surv(time, status) ~",colnames(clinical_riskscore)[i]))
    cox1 <- cph(fmla1, data = norm.stat.al,surv = T,x = T,y = T)
    fp1 <- predict(cox1)
    fp.al=cbind(fp.al,fp1)
  }
  colnames(fp.al)=c('Nomogram',colnames(clinical_riskscore))
  fp.al=crbind2DataFrame(fp.al)
  fp.al$status=norm.stat.al$status
  mg_plotDCA(fp.al$status
             ,c('Nomogram',colnames(clinical_riskscore))
             ,c('Nomogram',colnames(clinical_riskscore)),fp.al)
  #plot(cal1,xlim=c(0,1),ylim=c(0,1))
  #plot(cal3,xlim=c(0,1),ylim=c(0,1))
  #plot(cal5,xlim=c(0,1),ylim=c(0,1))
  plot(nom)
  options(datadist=NULL)
  return(list(Mod=cox2,Cindex=cindex,CutTime=cut.time))
}

pdf('results/ana/10.module.sigmut/fig12C.pdf', width = 12, height = 10)
nom.plot=mg_nomogram(data.frame(Senescore=tcga_cox_datas$riskscore,
                                Stage=tcga_cox_datas$Stage),
                     os = tcga_cox_datas$OS.time,
                     status = tcga_cox_datas$OS,
                     mks = c(1,3,5))
dev.off()

mg_nomogram_buti(nom.plot$Mod,cut.time = c(1*365,3*365,5*365))

#12、风险得分与生物学特征的关系####
dir.create('results/ana/11.module.feat')
library(ggplot2)
library(ggpubr)
#CCP
tcga.risk.ccp<-merge(tcga.ccp.subtype,tcga.module.risk$result[,c("Samples","riskscore","Risk")],by='Samples')
head(tcga.risk.ccp)
write.table(tcga.risk.ccp,'results/ana/11.module.feat/tcga.risk.ccp.txt',quote = F,row.names = F,sep='\t')
fig13a<-ggplot(tcga.risk.ccp, aes(x = riskscore, y = CCP))+
  geom_point()+
  geom_smooth(method = "lm", color = "blue", fill = "lightgray")+
  stat_cor(method = "pearson")+
  theme_bw()+
  theme(panel.grid.major =element_blank(), 
        panel.grid.minor = element_blank(),
        panel.background = element_blank())+xlab('Senescore')+ylab('CCP Score')
fig13a
#端粒酶
tcga.risk.telomere<-merge(tcga.telomere.subtype,tcga.module.risk$result[,c("Samples","riskscore","Risk")],by='Samples')
head(tcga.risk.telomere)
write.table(tcga.risk.telomere,'results/ana/11.module.feat/tcga.risk.telomere.txt',quote = F,row.names = F,sep='\t')
fig13b<-ggplot(tcga.risk.telomere, aes(x = riskscore, y = pathway))+
  geom_point()+
  geom_smooth(method = "lm", color = "blue", fill = "lightgray")+
  stat_cor(method = "pearson")+
  theme_bw()+
  theme(panel.grid.major =element_blank(), 
        panel.grid.minor = element_blank(),
        panel.background = element_blank())+xlab('Senescore')+ylab('Telomere Extension By Telomerase Score')
fig13b
#缺氧
tcga.risk.hypoxia<-merge(tcga_hypoxia.subtype,tcga.module.risk$result[,c("Samples","riskscore","Risk")],by='Samples')
head(tcga.risk.hypoxia)
write.table(tcga.risk.hypoxia,'results/ana/11.module.feat/tcga.risk.hypoxia.txt',quote = F,row.names = F,sep='\t')
fig13c<-ggplot(tcga.risk.hypoxia, aes(x = riskscore, y = pathway))+
  geom_point()+
  geom_smooth(method = "lm", color = "blue", fill = "lightgray")+
  stat_cor(method = "pearson")+
  theme_bw()+
  theme(panel.grid.major =element_blank(), 
        panel.grid.minor = element_blank(),
        panel.background = element_blank())+xlab('Senescore')+ylab('Hypoxia Score')
fig13c
#血管生成
tcga.risk.Angiogenesis<-merge(tcga_Angiogenesis.subtype,tcga.module.risk$result[,c("Samples","riskscore","Risk")],by='Samples')
head(tcga.risk.Angiogenesis)
write.table(tcga.risk.Angiogenesis,'results/ana/11.module.feat/tcga.risk.Angiogenesis.txt',quote = F,row.names = F,sep='\t')
fig13d<-ggplot(tcga.risk.Angiogenesis, aes(x = riskscore, y = pathway))+
  geom_point()+
  geom_smooth(method = "lm", color = "blue", fill = "lightgray")+
  stat_cor(method = "pearson")+
  theme_bw()+
  theme(panel.grid.major =element_blank(), 
        panel.grid.minor = element_blank(),
        panel.background = element_blank())+xlab('Senescore')+ylab('Angiogenesis Score')
fig13d
fig13<-mg_merge_plot(fig13a,fig13b,fig13c,fig13d,nrow = 2,ncol = 2,labels = LETTERS[1:4])
ggsave('results/ana/11.module.feat/Fig13.pdf',fig13,height = 9,width = 9)
#免疫
tcga.risk.immnu<-cbind.data.frame(tcga.cier[rownames(tcga.module.risk$result),1:22],
                                  Senescore=tcga.module.risk$result$riskscore)
tcga.risk.immnu=tcga.risk.immnu[,apply(tcga.risk.immnu,2,function(x){return(sd(x)>0)})]
tcga.risk.immnu.cor <- Hmisc::rcorr(as.matrix(tcga.risk.immnu))
tcga.risk.immnu.cor.p=tcga.risk.immnu.cor$P
tcga.risk.immnu.cor.r=tcga.risk.immnu.cor$r
#过滤
tcga.risk.immnu.cor.p[is.na(tcga.risk.immnu.cor.p)]<-0
col1 = colorRampPalette(c('blue', 'white','red'))
pdf('results/ana/11.module.feat/Fig13E.pdf',height = 9,width = 9)
corrplot::corrplot(as.matrix(t(tcga.risk.immnu.cor.r)), 
                   p.mat = as.matrix(t(tcga.risk.immnu.cor.p)),
                   mar = c(0,0,1,1),
                   col=col1(100),
                   tl.srt = 30,
                   tl.cex = 1,
                   tl.col = 'black',
                   tl.offset = 0.5,
                   cl.pos = c("b","r","n")[1], 
                   #cl.lim=c(-0.3,0.3),
                   cl.align.text = 'l',
                   cl.length = 5,
                   cl.ratio = 0.1,
                   cl.cex = 0.8,
                   addgrid.col = 'white',
                   method = 'color',
                   insig = 'label_sig',
                   sig.level=c(0.001,0.01,0.05),
                   pch.cex=1,
                   is.corr=T,
                   xpd=T
)
dev.off()
#13、风险的得分与免疫治疗的关系####
dir.create('results/ana/12.module.pd1')
library("IMvigor210CoreBiologies")
data(cds)
pheno<-pData(cds)
head(pheno)
exper_tpm=mg_get_immu_pd1_treament_exp()
exper_id=exper_tpm$fpkm
exper_id$symbol=rownames(exper_id)
rownames(exper_id)<-exper_id$symbol
exper_id$symbol<-NULL

exper_id_use<-log2(exper_id+1)
dim(exper_id_use)
range(exper_id_use)
rownames(exper_id_use)=gsub('-','__',rownames(exper_id_use))

imv.module.risk<-get_riskscore(dat = t(exper_id_use[names(tcga.module.risk$module.gene),rownames(pheno)]),
                               os = pheno$censOS,
                               os.time = pheno$os,
                               step=F,direction=c("both", "backward", "forward")[1])
#KM
fig14c<-ggplotKMCox(dat = data.frame(imv.module.risk$result$time,
                                     imv.module.risk$result$status,
                                     ifelse(imv.module.risk$result$riskscorez>=0,'H','L')),
                    title = 'IMvigor210 Senescore',add_text = '',
                    palette =  ggsci::pal_npg()(9),labs = c('High','Low'))
fig14c
imv.module.risk$result$Risk=ifelse(imv.module.risk$result$riskscorez>=0,'High','Low')
imv.risk<-merge(imv.module.risk$result[,c("Samples","riskscore","riskscorez","Risk")],
                data.frame(Samples=rownames(pheno),
                           binaryResponse=pheno$binaryResponse,
                           Stage=pheno$`TCGA Subtype`),
                by='Samples')
head(imv.risk)

fig14a<-sig_boxplot(dat = imv.risk[,c("binaryResponse","riskscore")],
                    leg = 'binaryResponse',ylab = 'Senescore',ggsci::pal_jco()(9))
fig14a

results=prop.table(table(imv.risk$binaryResponse,imv.risk$Risk),margin=2)
results1=reshape2::melt(results)
colnames(results1)<-c("binaryResponse","Senescore","Percentage")

results1$Percentage<-round(results1$Percentage,digits=2)
write.table(results1,'results/ana/12.module.pd1/IMV210.response.percentage.txt',quote = F,row.names = F,sep='\t')

fig14b=ggplot(results1,aes(x=Senescore,y=Percentage,fill=binaryResponse))+
  geom_bar(position = "fill",stat="identity")+ggsci::scale_fill_jco()+
  theme_bw()+
  geom_text(aes(label = Percentage),position=position_stack(vjust =0.5),size = 5)
fig14b
#I和II
sam=imv.risk[imv.risk$Stage %in% c('I','II'),"Samples"]
fig14d<-ggplotKMCox(dat = data.frame(imv.module.risk$result[sam,]$time,
                                     imv.module.risk$result[sam,]$status,
                                     ifelse(imv.module.risk$result[sam,]$riskscorez>=0,'H','L')),
                    title = 'I+II',add_text = '',
                    palette = ggsci::pal_npg()(10),labs = c('High','Low'))
fig14d
#III和IV
sam=imv.risk[imv.risk$Stage %in% c('III','IV'),"Samples"]
fig14e<-ggplotKMCox(dat = data.frame(imv.module.risk$result[sam,]$time,
                                     imv.module.risk$result[sam,]$status,
                                     ifelse(imv.module.risk$result[sam,]$riskscorez>=0,'H','L')),
                    title = 'III+IV',add_text = '',
                    palette = ggsci::pal_npg()(10),labs = c('High','Low'))
fig14e
#
#TIDE分析
exper_id_use1=exper_id_use[apply(exper_id_use,1,function(x){return(sd(x)>0.2)}),]
imv210_tide_dat <- t(scale(t(exper_id_use1[,rownames(imv.module.risk$result)]),scale = F))
boxplot(imv210_tide_dat[, 1:5])
rownames(imv210_tide_dat)=gsub('__','-',rownames(imv210_tide_dat))

dir.create('results/ana/12.module.pd1/TIDE')
write.table(imv210_tide_dat,
            file = 'results/ana/12.module.pd1/TIDE/imv210.tide.txt',
            quote = F, sep = '\t')

imv210_tide_dat<-read.csv('results/ana/12.module.pd1/TIDE/imv210.tide.res.csv',row.names = 1,stringsAsFactors = F)
imv210_tide_dat1<-cbind.data.frame(riskscore=imv.module.risk$result$riskscore,
                                   Risk=imv.module.risk$result$Risk,
                                   OS.time=imv.module.risk$result$time,
                                   OS=imv.module.risk$result$status,
                                   imv210_tide_dat[rownames(imv.module.risk$result),])
ggplotKMCox(imv210_tide_dat1[,c("OS.time","OS","Responder")])
imv210_tide_dat1=imv210_tide_dat1[order(imv210_tide_dat1$Responder,decreasing = T),]
fig14f<-sig_boxplot(dat = imv210_tide_dat1[,c("Responder","riskscore")],
                    leg = 'Responder',ylab = 'Senescore',
                    palette=ggsci::pal_jco()(9))
fig14f
fig14g<-sig_boxplot(dat = imv210_tide_dat1[,c("Responder","TIDE")],
                    leg = 'Responder',ylab = 'TIDE',
                    palette = ggsci::pal_jco()(9))
fig14g



fig14h<-ggplot(imv210_tide_dat1, aes(x = riskscore, y = TIDE))+
  geom_point()+
  geom_smooth(method = "lm", color = "red", fill = "lightgray")+
  stat_cor(method = "pearson")+
  theme_bw()+
  theme(panel.grid.major =element_blank(), 
        panel.grid.minor = element_blank(),
        panel.background = element_blank())+xlab('Senescore')+ylab('TIDE Score')
fig14h
# fig14ad<-mg_merge_plot(fig14a,fig14b,fig14c,fig14d,nrow = 1,ncol = 4,labels = LETTERS[1:4])
# fig14fh<-mg_merge_plot(fig14e,fig14f,fig14g,nrow = 1,ncol = 4,labels = LETTERS[5:7])
# fig14<-mg_merge_plot(fig14ad,fig14fh,nrow = 2,ncol = 1)
# fig14
# ggsave('results/ana/12.module.pd1/Fig14.pdf',fig14,height = 9,width = 15)
fig14ae<-mg_merge_plot(fig14a,fig14b,fig14c,fig14d,fig14e,nrow = 1,ncol = 5,labels = LETTERS[1:5])
#12、药物预测#####
dir.create('results/ana/13.module.drug')
library(pRRophetic)
library(ggplot2)
## Cisplatin,顺铂
set.seed(12345)
predictedPtype_Cisplatin <- pRRopheticPredict(as.matrix(tcga_tmp_log2_T[, rownames(tcga.module.risk$result)])
                                              , "Cisplatin"
                                              , "urogenital_system"
                                              , selection=1
                                              ,dataset = "cgp2016")
predictedPtype_Cisplatin <- data.frame(predictedPtype_Cisplatin)

tcga_durg_ic50_res <- predictedPtype_Cisplatin

drugs <- c("Cisplatin","Erlotinib","Rapamycin","Sunitinib","PHA-665752","MG-132","Paclitaxel","Cyclopamine","AZ628","Sorafenib","VX-680","Imatinib","TAE684","Crizotinib","Saracatinib","S-Trityl-L-cysteine","Z-LLNle-CHO","Dasatinib","GNF-2","CGP-60474","CGP-082996","A-770041","WH-4-023","WZ-1-84","BI-2536","BMS-509744","CMK","Pyrimethamine","JW-7-52-1","A-443654","GW843682X","MS-275","Parthenolide","KIN001-135","TGX221","Bortezomib","XMD8-85","Roscovitine","Salubrinal","Lapatinib","Vinorelbine","NSC-87877","QS11","CP466722","Midostaurin","Shikonin","AKT inhibitor VIII","Embelin","Bexarotene","Bleomycin","Phenformin")
dim(tcga_durg_ic50_res)
for (drug in drugs) {
  print(drug)
  set.seed(12345)
  tmpic50 <- pRRopheticPredict(as.matrix(tcga_tmp_log2_T[, rownames(tcga.module.risk$result)])
                               , drug
                               , "urogenital_system"
                               , selection=1
                               , dataset = "cgp2016")
  tmpic50 <- data.frame(tmpic50)
  colnames(tmpic50) <- drug
  tcga_durg_ic50_res <- cbind(tcga_durg_ic50_res, tmpic50)
}

dim(tcga_durg_ic50_res)
colnames(tcga_durg_ic50_res)
colnames(tcga_durg_ic50_res) <- gsub('predictedPtype_', '', colnames(tcga_durg_ic50_res))

dim(tcga_durg_ic50_res)
tcga_durg_ic50_res1 <- cbind.data.frame(tcga_durg_ic50_res[rownames(tcga.module.risk$result),],
                                        riskscore=tcga.module.risk$result$riskscore,
                                        Risk=tcga.module.risk$result$Risk)
head(tcga_durg_ic50_res1)
write.table(tcga_durg_ic50_res1,'results/ana/13.module.drug/tcga_durg_ic50_res.txt',quote = F,sep='\t',row.names = T)

fig15a<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[1])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[1],')'),
                    palette = ggsci::pal_npg()(9))
fig15a

fig15b<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[3])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[3],')'),
                    palette = ggsci::pal_npg()(9))
fig15b

fig15c<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[5])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[5],')'),
                    palette = ggsci::pal_npg()(9))
fig15c

fig15d<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[6])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[6],')'),
                    palette = ggsci::pal_npg()(9))
fig15d

fig15e<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[8])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[8],')'),
                    palette = ggsci::pal_npg()(9))
fig15e

fig15f<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[10])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[10],')'),
                    palette = ggsci::pal_npg()(9))
fig15f

fig15g<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[12])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[12],')'),
                    palette = ggsci::pal_npg()(9))
fig15g
fig15h<-sig_boxplot(dat = tcga_durg_ic50_res1[,c('Risk',drugs[19])],
                    leg = 'Senescore',ylab = paste0('Estimated IC50 (',drugs[19],')'),
                    palette = ggsci::pal_npg()(9))
fig15h

# fig15<-mg_merge_plot(fig15a,fig15b,fig15c,fig15d,
#                      fig15e,fig15f,fig15g,fig15h,
#                      nrow = 2,ncol = 4)
# fig15
fig15<-mg_merge_plot(fig15a,fig15b,fig15c,fig15d,fig15e,
                     nrow = 1,ncol = 5)
fig15
fig14<-mg_merge_plot(fig14ae,fig15,nrow = 2,ncol = 1,labels = c('','F'))
ggsave('results/ana/13.module.drug/Fig14.pdf',fig14,height = 9,width = 18)


save.image('project_002.RData')

